{--------------------------------------------------------}
{
{    Mdulo para abertura do Painel de Configurao no campo de edio
{
{    Autores:  Antonio Borges e Fabiano Ferreira
{
{    Em fevereiro de 2013
{
{    Aperfeioado porGlauco Frius em 6 de outubro de 2017
{
{--------------------------------------------------------}

Unit vtConfig;

interface

uses
    Windows,
    dvcrt,
    dvwin,
    dvForm,
    dvinet,
    dvSapGlb,
    vtmsg,
    SysUtils;

var
    gravaAsBuscas, informaOsTocadores, fazAtualizacaoAutomatica, comEfeitos: boolean;
    apagaArqMp4: boolean;
    confApaga : shortString;

procedure formConfig;

implementation

{-------------------------------------------------------------}

function primeiraLetra (s: string): char;
begin
    s := trim (s);
    delete (s, 2, 999);
    if s = '' then primeiraLetra := ' '
              else primeiraLetra := upcase (s[1]);
end;

{-------------------------------------------------------------}

function existeDir (dir: string): boolean;
var dirAtual: string;
begin
    getDir (0, dirAtual);
    {$I-}  chdir (dir);  {$I+}
    existeDir := ioresult = 0;
    chdir (dirAtual);
end;

{-------------------------------------------------------------}
{       consiste nome de diretrio da configurao
{-------------------------------------------------------------}

procedure consisteDirArq;
var erro: boolean;
    c, c2: char;
    confDirVideos: shortString;
    s: string;
    sz: array [0..144] of char;
    dirAtual: string;
begin
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    erro := false;
    if not existeDir (confDirVideos) then
        begin
            mensagem ('VTERDGRA', 1); {'Ateno! Diretrio de gravao inexistente'}
            sintWriteLn (confDirVideos);
            mensagem ('VTPOSCRI', 1);   {'Posso cri-lo? '}
            sintLeTecla (c, c2);
            writeln;
            if upcase(c) = 'N' then
                erro := true
            else
                begin
                     {$I-}  mkdir (confDirVideos);  {$I+}
                     if ioresult <> 0 then
                         begin
                             erro := true;
                             mensagem ('VTDGNCRI', 1); {'Diretrio no foi criado.'}
                         end;
                end;
        end;

    if erro then
begin
         mensagem ('VTASDACI', 1);  {'Assumindo o diretrio de acionamento'}
    getDir (0, dirAtual);
         sintWriteLn (dirAtual);

            s := '.';
            strPCopy (sz, s);
            writePrivateProfileString('VOXTUBE', 'DIRVIDEOS',     sz, 'DOSVOX.INI');
end;
end;

{-----------------------------}

procedure consisteDirVideos;
var erro: boolean;
    c, c2: char;
    confDirVideos: shortString;
    s: string;
    sz: array [0..144] of char;
    dirAtual: string;
begin
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    erro := false;
    if not existeDir (confDirVideos) then
        begin
            mensagem ('VTERDGRA', 1); {'Ateno! Diretrio de gravao inexistente'}
            sintWriteLn (confDirVideos);
            mensagem ('VTPOSCRI', 1);   {'Posso cri-lo? '}
            sintLeTecla (c, c2);
            writeln;
            if upcase(c) = 'N' then
                erro := true
            else
                begin
                     {$I-}  mkdir (confDirVideos);  {$I+}
                     if ioresult <> 0 then
                         begin
                             erro := true;
                             mensagem ('VTDGNCRI', 1); {'Diretrio no foi criado.'}
                         end;
                end;
        end;

    if erro then
begin
         mensagem ('VTASDACI', 1);  {'Assumindo o diretrio de acionamento'}
    getDir (0, dirAtual);
         sintWriteLn (dirAtual);

            s := '.';
            strPCopy (sz, s);
            writePrivateProfileString('VOXTUBE', 'DIRVIDEOS',     sz, 'DOSVOX.INI');
end;
end;

{-------------------------------------------------------------}

Procedure MolduraTela;
var j: byte;
begin
textcolor(white);
gotoxy(1,1);
write('+');
for j:=2 to 79 do write('-');
write('+', '');
for J:=1 to 23  do
  begin
  gotoxy(80, j+1);
  write('', '');
  end;
gotoxy(1,25);
write('+');
For j:=2 to 79  Do write('-');
gotoxy(1,6);
write('+');
for j:=2 to 79 do write('-');
write('');
gotoxy(1,23); write('+');
for j:=2 to 79  do write('-');
write('');
{mem[$B800:3998]:=217;}
textcolor(lightgray);
end;

{-------------------------------------------------------------}

Procedure Escrevetela;
begin
  textbackground(blue);
  textcolor (LightGray);
  Clrscr;
  MolduraTela;
  gotoxy(26,2);
  write( 'Programa VOXTUBE');
  gotoxy(29, 3);
  write ('Verso VOXTUBE 2.4g Glauco 15.7 atualizado em 28 de setembro de 2017');
  gotoxy(6, 4);
  Write(' Autores: Fabiano Ferreira');
  gotoxy(6, 5);
  write('           Professor Antonio Borges');
  gotoxy(6, 6);
  write('           Aperfeioado por Glauco Frius em 28 de setembro de 2017');
end;

{-------------------------------------------------------------}

procedure formConfig;
var confTocador0, confTocador1, confTocador2, confTocador3, confTocador4, confTocador5, confTocador6, confTocador7, confPag, confGra, confInfToc, confAciEfe, confAtualiza, confDirVideos,
    confSapi, confAudiobitrate, confAudioresample, confAudiochanels: shortString;
     velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
    parm: array [0..255] of char;
    comSapi: boolean;
    i: integer;
    s, textoAProcurar, memo0: string;
    erro : Integer;
    dirGravaBuscas: boolean;

begin

    //Recuperando informaes do DOSVOX.INI

    val (sintAmbiente('VOXTUBE', 'VELOCIDADE'), velGeral, erro);
    if erro <> 0 then velGeral := 0;
    confPag  := (sintAmbiente('VOXTUBE', 'VIDEOSPORPAGINA'));
    confInfToc  := (sintAmbiente('VOXTUBE', 'INFORMATOCADOR'));
    if (confInfToc = 'S') or (confInfToc = 'SIM') then confInfToc := 'SIM' else confInfToc := 'NO';
    confAciEfe  := (sintAmbiente('VOXTUBE', 'ACIONAEFEITOS'));
    if (confAciEfe = 'S') or (confAciEfe = 'SIM') then confAciEfe := 'SIM' else confAciEfe := 'NO';
    confAtualiza  := (sintAmbiente('VOXTUBE', 'ATUALIZA'));
    if (confAtualiza = 'S') or (confAtualiza = 'SIM') then confAtualiza := 'SIM' else confAtualiza := 'NO';
    confGra  := (sintAmbiente('VOXTUBE', 'GRAVABUSCA'));
    if (confGra = 'S') or (confGra = 'SIM') then confGra := 'SIM' else confGra := 'NO';
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if (confApaga = 'S') or (confApaga = 'SIM') then confApaga := 'SIM' else confApaga := 'NO';

    confSapi       := (sintAmbiente('VOXTUBE', 'SAPIATIVADO'));
    if (confSapi = 'S') or (confSapi = 'SIM') then confSapi := 'SIM' else confSapi := 'NO';

    val (sintAmbiente('VOXTUBE', 'TIPOSAPI'), confTipoSapi, erro);
    if erro <> 0 then val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
    if erro <> 0 then confTipoSapi := 4;

    val (sintAmbiente('VOXTUBE', 'NUMEROSAPI'), confNum, erro);
    if erro <> 0 then confNum:= 1;

    val (sintAmbiente('VOXTUBE', 'VELOCIDADESAPI'), confVeloc, erro);
    if erro <> 0 then confVeloc:= 0;
    val (sintAmbiente('VOXTUBE', 'TONALIDADESAPI'), confTonal, erro);
    if erro <> 0 then confTonal:= 0;

    confAudiobitrate  := (sintAmbiente('VOXTUBE', 'AUDIOBITRATE'));
    confAudioresample  := (sintAmbiente('VOXTUBE', 'AUDIORESAMPLE'));
    confAudiochanels  := (sintAmbiente('VOXTUBE', 'AUDIOCHANELS'));

    confTocador0 := (sintAmbiente('VOXTUBE', 'TOCADOR0'));
    confTocador1 := (sintAmbiente('VOXTUBE', 'TOCADOR1'));
    confTocador2 := (sintAmbiente('VOXTUBE', 'TOCADOR2'));
    confTocador3 := (sintAmbiente('VOXTUBE', 'TOCADOR3'));
    confTocador4 := (sintAmbiente('VOXTUBE', 'TOCADOR4'));
    confTocador5 := (sintAmbiente('VOXTUBE', 'TOCADOR5'));
    confTocador6 := (sintAmbiente('VOXTUBE', 'TOCADOR6'));
    confTocador7 := (sintAmbiente('VOXTUBE', 'TOCADOR7'));

    // Apresentando o formulrio

    textBackground (BLUE);
    writeln;
    mensagem ('VTPAICON', 1); {'Painel de configurao'}
    sintBip; sintBip;
    textBackground (BLACK);
    for i := 10 to 29 do
        begin
             gotoxy (1, i);  clreol;
        end;
    gotoxy (1, 10);

    formCria;
    formCampoInt ('VTVELC',   pegaTextoMensagem ('VTVELC')   {'Velocidade: '},         velGeral); {''}
    formCampo    ('VTVIDPAG', pegaTextoMensagem ('VTVIDPAG') {'Vdeos por pgina: '},    confPag, 2); {''}
    formCampo    ('VTINFTOC', pegaTextoMensagem ('VTINFTOC') {'Informa o tocador? '},    confInfToc, 4); {'Informa o tocador? '}
    formCampo    ('VTACIEFE', pegaTextoMensagem ('VTACIEFE') {'Aciona efeitos? '},    confAciEfe, 4); {''}
    formCampo    ('VTFAZATU', pegaTextoMensagem ('VTFAZATU') {'Inicia atualizando o Youtube-dl e o Voxtube?'},    confAtualiza, 4); {''}
    formCampo    ('VTGRABUS', pegaTextoMensagem ('VTGRABUS') {'Grava busca? '},    confGra, 4); {''}
    formCampo    ('VTDIRVID', pegaTextoMensagem ('VTDIRVID') {'Diretrio de gravao dos vdeos: '},    confDirVideos, 80); {''}
    formCampo    ('VTAPAORI', pegaTextoMensagem ('VTAPAORI') {'Apaga mp4 original? '},    confApaga, 4); {''}
    formCampo    ('VTCOMSAP', pegaTextoMensagem ('VTCOMSAP') {'Com SAPI? '},           confSapi, 4); {''}
    formCampoInt ('VTTIPSAP', pegaTextoMensagem ('VTTIPSAP') {'Tipo SAPI, 3, 4 ou 5?: '}, confTipoSapi); {''}
    formCampoInt ('VTNUMSAP', pegaTextoMensagem ('VTNUMSAP') {'Nmero SAPI: '},        confNum); {''}
    formCampoInt ('VTVEL',    pegaTextoMensagem ('VTVEL')    {'Velocidade SAPI: '},    confVeloc); {''}
    formCampoInt ('VTTOM',    pegaTextoMensagem ('VTTOM')    {'Tonalidade SAPI: '},    confTonal); {''}
    formCampo    ('VTQUALID', pegaTextoMensagem ('VTQUALID') {'Qualidade do udio: '},    confAudiobitrate, 7); {''}
    formCampo    ('VTTAXAMO', pegaTextoMensagem ('VTTAXAMO') {'Digite a taxa de amostragem, altera a afinao e a durao do udio: '},    confAudioresample, 8);
{''}
    formCampo    ('VTMONSTE', pegaTextoMensagem ('VTMONSTE') {'Digite 1 para Mono e 2 para  estreo: '},    confAudiochanels, 1); {''}
    formCampo    ('VTTOCENT', pegaTextoMensagem ('VTTOCENT') {'Tocador 0 para o ENTER: '},    confTocador0, 80); {''}
    formCampo    ('VTTOCACR', pegaTextoMensagem ('VTTOCACR') {'Tocador 1 para o cedilha: '},    confTocador1, 80); {''}
    formCampo    ('VTTOCADX', pegaTextoMensagem ('VTTOCADX') {'Tocador 2 para o X: '},    confTocador2, 80); {''}
    formCampo    ('VTTOCACX', pegaTextoMensagem ('VTTOCACX') {'Tocador 3 para o CTRL+X: '},    confTocador3, 80); {''}
    formCampo    ('VTTOCADV', pegaTextoMensagem ('VTTOCADV') {'Tocador 4 para o V: '},    confTocador4, 80); {''}
    formCampo    ('VTTOCACV', pegaTextoMensagem ('VTTOCACV') {'Tocador 5 para o CTRL+V: '},    confTocador5, 80); {''}
    formCampo    ('VTTOCADR', pegaTextoMensagem ('VTTOCADR') {'Tocador 6 para a Raiz: '},    confTocador6, 80); {''}
    formCampo    ('VTTOCADB', pegaTextoMensagem ('VTTOCADB') {'Tocador 7 para a Barra Vertical: '},    confTocador7, 80); {''}
    formEdita (true);

    //Efetuando modificaes

    if (velGeral < 0) or (velGeral > 5) then
        velGeral:= 0;

    // gravando DOSVOX.INI

        if confPag > intToStr(50) then
        confPag := intToStr(50);
        if confPag < intToStr(1) then
        confPag := intToStr(25);

        if confAudiochanels > intToStr(2) then
        confAudiochanels := intToStr(2);
        if confAudiochanels < intToStr(1) then
        confAudiochanels := intToStr(2);

    writePrivateProfileString ('VOXTUBE', 'VELOCIDADE', pchar(intToStr(velGeral)), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confPag));
    writePrivateProfileString ('VOXTUBE', 'VIDEOSPORPAGINA', (parm), 'DOSVOX.INI');

    strpCopy (parm, maiuscAnsi(confInfToc));
    writePrivateProfileString ('VOXTUBE', 'INFORMATOCADOR', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAciEfe));
    writePrivateProfileString ('VOXTUBE', 'ACIONAEFEITOS', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAtualiza));
    writePrivateProfileString ('VOXTUBE', 'ATUALIZA', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confGra));
    writePrivateProfileString ('VOXTUBE', 'GRAVABUSCA', (parm), 'DOSVOX.INI');
    strpCopy (parm, confDirVideos);
    writePrivateProfileString ('VOXTUBE', 'DIRVIDEOS', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confApaga));
    writePrivateProfileString ('VOXTUBE', 'MP4APAGA', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confSapi));
    writePrivateProfileString ('VOXTUBE', 'SAPIATIVADO', (parm), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'TIPOSAPI', pchar(intToStr(confTipoSapi)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'NUMEROSAPI', pchar(intToStr(confNum)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'VELOCIDADESAPI', pchar(intToStr(confVeloc)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'TONALIDADESAPI', pchar(intToStr(confTonal)), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudiobitrate));
    writePrivateProfileString ('VOXTUBE', 'AUDIOBITRATE', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudioresample));
    writePrivateProfileString ('VOXTUBE', 'AUDIORESAMPLE', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudiochanels));
    writePrivateProfileString ('VOXTUBE', 'AUDIOCHANELS', (parm), 'DOSVOX.INI');

    strpCopy (parm, confTocador0);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR0', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador1);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR1', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador2);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR2', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador3);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR3', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador4);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR4', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador5);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR5', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador6);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR6', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador7);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR7', (parm), 'DOSVOX.INI');

    consisteDirArq;
    consisteDirVideos;

    mensagem ('VTAGUARC', 1); {'Aguarde, configurando'}
    sintPara;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4  then
begin
  apagaArqMp4 :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4 then
begin
  apagaArqMp4:=true;
end;

    s := sintAmbiente ('VOXTUBE', 'DIRVIDEOS');
    if s = '' then
    begin
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) = 'N';
    end
    else
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) <> 'N';
        if dirGravaBuscas then
begin
end;

    if confSapi = '' then
        comSapi := primeiraLetra (sintAmbiente ('VOXTUBE', 'SAPIATIVADO')) = 'S'
    else
        comSapi := primeiraLetra (confSapi) = 'S';

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 0
    else
        val (s, velGeral, erro);
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);

    writeln;
        mensagem ('VTOK', 1); {'Ok!'}
    sintBip; sintBip; sintBip;
    escreveTela;

    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
    if textoAProcurar <> '' then
    begin
        mensagem ('VTDIGBUS', 0);  {'Digite sua busca, ou use as setas para folhear a memria'}
    sintetiza (textoAProcurar);
    end
    else
    begin
    memo0 := sintambiente('VOXTUBE','CP0');
        mensagem ('VTDIGBUS', 0);  {'Digite sua busca, ou use as setas para folhear a memria'}
    sintetiza (memo0);
    end;
end;

end.
