{--------------------------------------------------------}
{
{    VoxTube - utilitrio de acessibilizao do YouTube
{
{    Autores:  Antonio Borges e Fabiano Ferreira
{
{    Em fevereiro de 2013
{
{    Aperfeioado porGlauco Frius
{
{--------------------------------------------------------}

program voxtube;

uses
    Videovox,
    IniFiles,
    dvcrt,
    dvwin,
dvForm,
    dvHora,
    dvinet,
    dvexec,
    dvSapGlb,
    dvArq,
    vtmsg,
    SysUtils,
    superObject,
    Windows,
    shellapi,
    vtrede,
    pipe,
    dvplay,
    vtDecod;

const
    DEBUG = false;
    VERSAO = '2.4g Glauco 15.7';
tamprog = 189;

    YOUTUBEKEY='AIzaSyCEicGe3yo0O23-rXssrzUieFrYc4mMo6A';
    GOOGLEAPIHOST='www.googleapis.com';
    YOUTUBESEARCHURL = '/youtube/v3/search';
    YOUTUBEVIDEOSURL = '/youtube/v3/videos';

type
    TInfoFilme = record
        id: string;
        titulo, autor, conteudo: string;
        paginaWeb: string;
datadepublicacao : string;
horadepublicacao : string;
        duracao, visualizacoes: integer;
    end;

var
titulojan : string;
filtro : string;
    lido: ISuperObject;
    lidoInfo: ISuperObject;
    gravaAsBuscas, informaOsTocadores, informaAsVisualizacoes, fazAtualizacaoAutomatica, comEfeitos: boolean;
    apagaArqMp4: boolean;
    confApaga : shortString;
    tecla: char;
    pagNoYouTube, maxPag: integer;
    ultFolheado, num: integer;
    vpp: string;
    meuNome: array [0..101] of char;
    letraMemoria, lm: string;

    listaDeFilmes: TSuperArray;
    quantNoYouTube: integer;
    iniciandoProg: boolean;
    tokenPag, tokenPagAnt, tokenProxPag: string;

{--------------------------------------------------------}
{           prepara o pedido de busca no youtube
{--------------------------------------------------------}

function pedeListaVideos (busca: string): string;
var
    s: string;
begin
    vpp := sintambiente('VOXTUBE','VIDEOSPORPAGINA');

filtro := copy(busca,1,4);
filtro := uppercase(filtro);

    s := 'GET ' + YOUTUBESEARCHURL + '?key=' + YOUTUBEKEY ;

if filtro = '#CN=' then
s := s +                       '&type=channel'
else
if filtro = '#PL=' then
s := s +                       '&type=playlist'
else
if filtro = '#LV=' then
s := s +                       '&type=stream'
else
s := s + '&type=video';

if filtro[1] = '#' then
busca := copy(busca,5,999999);

    busca := stringToURL(busca);

s := s +                         '&part=id,snippet' +
                       '&q=' + busca +
                       '&maxResults=' + intToStr(strToInt(vpp));
    if tokenPag<>'' then
        s := s + '&pageToken='+tokenPag;
    tokenPag := '';

    s := s + ' HTTP/1.0';
    result := s;
end;

{--------------------------------------------------------}
{           prepara o pedido de busca no youtube
{--------------------------------------------------------}

function pedeInfoVideos (id: string): string;
var
    s: string;
begin
    s := 'GET ' + YOUTUBEVIDEOSURL + '?key=' + YOUTUBEKEY +
                       '&part=id,contentDetails,statistics,snippet' +
                       '&id=' + id;
    s := s + ' HTTP/1.0';
    result := s;
end;

{--------------------------------------------------------}
{              manda um pedido ao Youtube
{--------------------------------------------------------}

function pedeAoYoutube (pedidoHTTP: string): string;
var
    pbuf: PbufRede;
    s: string;
    c: char;
    ok: boolean;
    sock: integer;
begin
    abreWinsock;
    sock := abreConexaossl ('gdata.youtube.com', 443);
    if sock <= 0 then
        begin
            mensagem('VTNAOCON', 1); {'No consegui realizar a conexo.'}
            result := '';
            exit;
        end;

    writelnRede (sock, pedidoHttp);
    writelnRede (sock, 'Host: ' + GOOGLEAPIHOST);
    writelnRede (sock, 'User-Agent: Webvox 5.2d');
    writelnRede (sock, 'Accept-Language: pt-br');
    writelnRede (sock, 'UA-CPU: x86');
    writelnRede (sock, '');

    pbuf := inicBufRede (sock);
    repeat
        ok := readlnBufRede(pbuf, s, 500);
    until (not ok) or (s = '');

    s := '';
    repeat
        while not temDadoBufRede(pbuf) do delay (100);
        ok := leCaracBufRede(pbuf, c);
        if ok then s := s + c;
    until not ok;

    fimBufRede (pbuf);
    fechaConexao (sock);
    result := s;
    fechaWinsock;
end;

{--------------------------------------------------------}
{           Obtem a data de publicao do vdeo
{--------------------------------------------------------}

function obtemdatafilme(s: string): string;
var   p : integer;
dia, mes, ano : string;
begin
p := pos('-',s)-1;
ano := copy (s,1,p);
s := copy(s,p+2,999999);
p := pos('-',s)-1;
mes := copy (s,1,p);
s := copy(s,p+2,999999);

p := pos('T',s)-1;
dia := copy (s,1,p);

obtemdatafilme := dia+'/'+mes+'/'+ano;
end;

{--------------------------------------------------------}
{           Obtem a hora de publicao do vdeo
{--------------------------------------------------------}

function obtemhorafilme(s: string): string;
var
hora : string;
begin
hora := copy(s,pos('T',s)+1,999999);

hora := copy(hora,1,pos('.',hora)-1);

obtemhorafilme := hora;
end;

{--------------------------------------------------------}
{           remove caracteres de formatao html
{--------------------------------------------------------}

function formata (s: string): string;
var
    saida: string;
begin

    saida := '';
    textColor (White);
    while (s <> '') do
        if copy (s, 1, 6) = '&quot;' then
            begin
                saida := saida + '"';
                delete (s, 1, 6);
            end
        else
        if copy (s, 1, 5) = '&#39;' then
            begin
                saida := saida + '''';
                delete (s, 1, 5);
            end
        else
        if (copy (s, 1, 3) = '<b>') OR
           (copy (s, 1, 3) = '<i>') then   delete (s, 1, 3)
        else
        if (copy (s, 1, 4) = '</b>') or
           (copy (s, 1, 4) = '</i>') then  delete (s, 1, 4)

        else
            begin
                saida := saida + s[1];
                delete (s, 1, 1);
            end;
    result := saida;
end;

{--------------------------------------------------------}
{ rotina auxiliar para guardar o formato json para debug
{--------------------------------------------------------}

procedure debuga (s: string);
var
    arq: textfile;
begin
    if not DEBUG then exit;
    assignFile (arq, 'debug.json');
    rewrite (arq);
    write (arq, s);
    closefile (arq);
end;

{--------------------------------------------------------}
{         monta a estrutura para folhear os filmes
{--------------------------------------------------------}

function montaFolheamento (s: string; indice_atual: integer): boolean;   // retorna tambm a lista de filmes
var
    filme: ISuperObject;
    titulo: string;
    wstring: WideString;
    i: integer;
    nLidos: integer;
begin
    wstring := s;  // Superobject s trabalha com widestring
    lido := TSuperObject.ParseString2(pWideChar(wstring));

    try
        listaDeFilmes := lido['items'].AsArray;
        nlidos := listaDeFilmes.Length;
        quantNoYouTube := lido['pageInfo']['totalResults'].asInteger;
    except
        quantNoYouTube := 0;
        nlidos := 0;
    end;

    try
        tokenPagAnt := lido['prevPageToken'].asString;
    except
        tokenPagAnt := '';
    end;
    try
        tokenProxPag := lido['nextPageToken'].asString;
    except
        tokenProxPag := '';
    end;

    window (1, 1, 80, 25);
    gotoxy (1, 3);
    clreol;
    sintWriteInt (nlidos);
    mensagem('VTNUMLID', 0);  {'Registros'}

    if (quantNoYouTube <> 0) and (indice_atual = 1) then
        begin
            mensagem('VTUNIVER', 0);   {' de um universo de '}
            sintWriteInt (quantNoYouTube);
        end;
    writeln;
    textbackground (RED);
    writeln ('-------------------------------------------------------------------------------');
    textbackground (BLACK);

    window (1, wherey, 80, 25);
    folheiaCria (wherex, wherey, 80, 20);
    for i := 0 to nlidos-1 do
        begin
            filme := listaDeFilmes.O[i];
            s := filme['snippet']['title'].AsString;
            titulo := formata (Utf8ToAnsi(s));
            folheiaAdiciona(titulo);
        end;

    result := nlidos <> 0;
end;

{--------------------------------------------------------}
{            Descobre qual  o navegador padro
{--------------------------------------------------------}

function GetDefaultBrowser: string;
var
    tmp : PChar;
    res : PChar;
begin
    tmp := StrAlloc(255);
    res := StrAlloc(255);
    try
        GetTempPath(255,tmp);
        FileCreate(tmp+'htmpl.htm');
        FindExecutable('htmpl.htm',tmp,Res);
        Result := ExtractFilePath(res) + ExtractFileName(res);
        SysUtils.DeleteFile(tmp+'htmpl.htm');
    finally
        StrDispose(tmp);
        StrDispose(res);
    end;
end;

      function simplifica (nomeOrig: string): string;
      var nome: string;
      begin
          nome := nomeOrig;
          while pos (':', nome) > 0 do
              delete (nome, 1, pos (':', nome) );
          while pos ('\', nome) > 0 do
              delete (nome, 1, pos ('\', nome) );
          while pos ('/', nome) > 0 do
              delete (nome, 1, pos ('/', nome) );

          if nome = '' then nome := 'x.dat';
          simplifica := nome;
      end;

{--------------------------------------------------------}
{            seleciona o nmero com as setas
{--------------------------------------------------------}

function selSetasNumerosVid: char;

var n: integer;
const
    tabLetrasOpcoes: string [6] = '123456';

begin
    popupMenuCria (wherex, wherey, 50, 6, MAGENTA);
PopUpMenuAdiciona ('VTMP4', 'mp4');
PopUpMenuAdiciona ('VTOGG', 'ogg');
PopUpMenuAdiciona ('VTFLV', 'flv');
PopUpMenuAdiciona ('VTWEBM', 'webm');
PopUpMenuAdiciona ('VTMKV', 'mkv');
PopUpMenuAdiciona ('VTAVI', 'avi');
    while keypressed do readkey;

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasNumerosVid := tabLetrasOpcoes[n]
    else
begin
        selSetasNumerosVid := ENTER;
end;
    writeln;
end;

{--------------------------------------------------------}
{            seleciona o nmero com as setas
{--------------------------------------------------------}

function selSetasNumerosAud: char;

 var n: integer;
const
    tabLetrasOpcoes: string [7] = '1234567';

begin
    popupMenuCria (wherex, wherey, 50, 7, MAGENTA);
PopUpMenuAdiciona ('VTM4A', 'm4a');
PopUpMenuAdiciona ('VTAAC', 'aac');
PopUpMenuAdiciona ('VTOGG', 'ogg');
PopUpMenuAdiciona ('VTMP3', 'mp3');
PopUpMenuAdiciona ('VTOPUS', 'opus');
PopUpMenuAdiciona ('VTWAV', 'wav');
PopUpMenuAdiciona ('VTFLAC', 'flac');
    while keypressed do readkey;

    n := popupMenuSeleciona;
    if n > 0 then
        selSetasNumerosAud := tabLetrasOpcoes[n]
    else
begin
        selSetasNumerosAud := ENTER;
end;
    writeln;
end;

{tocador interno}

procedure  tocadorinterno(enderecovideo, nomedisp: string);
var s : string;
tocando : boolean;
c : char;
limitein : integer;
limiteout : integer;
begin
tocando := false;
limitein := 1000;
limiteout := 250;

if not mopen(enderecovideo,nomedisp) then exit;

preparavideo(nomedisp,crtwindow);
if mplay(nomedisp) then tocando := true;
while tocando do
begin
c := readkey;
case c of
' ': mpause(nomedisp);
esc: tocando := false;
cima: mvolup(nomedisp);
baix: mvoldown(nomedisp);
dir: mgo(nomedisp);
esq: mback(nomedisp);
'g': begin
sintwriteln ('Informe o valor em segundos:');
sintreadln(s);
mgoto(strtoint(s)*5000,nomedisp);
end;
'v': begin
sintwriteln ('Informe o valor entre 0 e 1000');
sintreadln(s);
mvolset(strtoint(s),nomedisp);
end;
'+': fadein(50,limitein,nomedisp);
'-': fadeout(50,limiteout,nomedisp);
'(': limitein := volume;
')': limiteout := volume;

end;
end;
mclose(nomedisp);
end;

{--------------------------------------------------------}
{       exibe o vdeo selecionado
{--------------------------------------------------------}

procedure tocavideo (pagina: string; teclou_ctrl_enter: boolean; i: integer);
var player : string;
    parametro : string;
    urlverdadeira : string;
begin

if i = 0 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR0');
    if player = '' then
            mensagem ('VTNENCT0', 1); {'No encontrei o tocador interno, vou usar o tocador do navegador'}
    end
else
if i = 1 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR1');
    if player = '' then
            mensagem ('VTNENCT1', 1); {'No encontrei o tocador 1, vou usar o tocador do navegador'}
    end
else
if i = 2 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR2');
    if player = '' then
            mensagem ('VTNENCT2', 1); {'No encontrei o tocador 2, vou usar o tocador do navegador'}
    end
else
if i = 3 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR3');
    if player = '' then
            mensagem ('VTNENCT3', 1); {'No encontrei o tocador 3, vou usar o tocador do navegador'}
    end
else
if i = 4 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR4');
    if player = '' then
            mensagem ('VTNENCT4', 1); {'No encontrei o tocador 4, vou usar o tocador do navegador'}
    end
else
if i = 5 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR5');
    if player = '' then
            mensagem ('VTNENCT5', 1); {'No encontrei o tocador 5, vou usar o tocador do navegador'}
    end
else
if i = 6 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR6');
    if player = '' then
            mensagem ('VTNENCT6', 1); {'No encontrei o tocador 6, vou usar o tocador do navegador'}
    end
else
if i = 7 then
    begin
    player := sintambiente('VOXTUBE','TOCADOR7');
    if player = '' then
            mensagem ('VTNENCT7', 1); {'No encontrei o tocador 7, vou usar o tocador do navegador'}
    end;

    // sugesto: verificar se parmetro veio com aspas
    if pos(' ', player) <> 0 then
    begin
        player := '"' + player + '"';
    end;

if i = 0 then
begin
    urlverdadeira := linkreal1(pagina);
    delay(1000);
end
else //Para o mpc-hc e o VLC tocarem
    urlverdadeira := linkreal(pagina);
    delay(1000);

    if (player = '') or (teclou_ctrl_enter) or (urlverdadeira = '') then
        begin
            if (urlverdadeira = '') and (player <> '') and (teclou_ctrl_enter = false) then

                    mensagem ('VTNTOCA',1);  {'Execuo via player no disponvel.'}

            player := GetDefaultBrowser;
            urlverdadeira := pagina;

            if InformaOsTocadores = true then
            mensagem ('VTABNAV', 1);  {'Abrindo navegador. Acione ALT F4 quando terminar.'}
            executaProg(player, '', urlverdadeira + parametro);
        end
    else
if player  = 'INTERNO' then
tocadorinterno(urlverdadeira,'meuvideo')
else
        executaProgEx(player, '', urlverdadeira + parametro, SW_HIDE);

if player <> 'INTERNO' then delay (2000);
    while getForegroundWindow <> crtWindow do delay (50);
end;

{-------------------------------------------------------------}
{                       executa um programa
{-------------------------------------------------------------}

function executaProg (nomeProg, nomeDir, nomeArq: string): boolean;
var
    pprog, pdir, pparam: array [0..100] of char;
    erro: tHandle;

begin
    executaProg := true;
    strPcopy (pprog, nomeProg);
    strPCopy (pdir, nomeDir);
    strPcopy (pparam, nomeArq);

    GetWindowText(crtWindow, meuNome, 100);

    erro := ShellExecute(crtWindow, 'open', pprog, pparam, pdir, SW_SHOWNORMAL);
    if erro < 32 then
        begin
            textBackground (RED);
            mensagem ('VTNAOEXE', 0);  {'No foi possvel executar esse programa, erro  #'}
            sintWriteInt (erro);
            textBackground (RED);
            writeln;
            executaProg := false;
        end;
end;

{--------------------------------------------------------}
{        espera o titulo da janela ficar o mesmo
{--------------------------------------------------------}

procedure esperaProgVoltar;
var
    s: string;
    erro, tempoEspera: integer;
begin
    esperaProgAtivar;
    repeat
        delay (1000);
    until getForegroundWindow = crtWindow;
    s := sintAmbiente ('DOSVOX', 'TEMPOESPERAPROGVOLTAR');
    val (s, tempoEspera, erro);
    if erro <> 0 then tempoEspera := 1000;
    if (tempoEspera < 0) or (tempoEspera > 1000) then tempoEspera := 1000;
    delay (tempoEspera);
end;

{--------------------------------------------------------}
{          obtem as informaes do filme
{--------------------------------------------------------}

function obtemInfoFilme (ultFolheado: integer): TInfoFilme;
var
    s: string;
    p: integer;
    wstring: WideString;
    filmeSelec: ISuperObject;
    infos: TSuperArray;
    infoFilme: TInfoFilme;

begin
    with infoFilme do
        begin
            filmeSelec := listaDeFilmes.O[ultFolheado-1];

            id := filmeSelec['id']['videoId'].AsString;
            s := filmeSelec['snippet']['publishedAt'].AsString;
datadepublicacao := obtemdatafilme(s);
horadepublicacao := obtemhorafilme(s);

            s := filmeSelec['snippet']['title'].AsString;
            titulo := formata (Utf8ToAnsi(s));

            s := filmeSelec['snippet']['channelTitle'].asString;
            autor := formata (Utf8ToAnsi(s));

            paginaWeb:='http://www.youtube.com/watch?v='+filmeSelec['id']['videoId'].AsString;

            s := pedeAoYoutube(pedeInfoVideos(infoFilme.id));
            debuga (s);
            wstring := s;  // Superobject s trabalha com widestring
            lidoInfo := TSuperObject.ParseString2(pWideChar(wstring));

            infos := lidoInfo['items'].AsArray;

            s := infos.O[0]['contentDetails']['duration'].AsString;
            delete (s, 1, 2);

            infoFilme.duracao := 0;
            try
                p := pos ('H', s);
                if p > 0 then
                    begin
                        infoFilme.duracao := infoFilme.duracao +
                                             3600 * strToInt(copy (s, 1, p-1));
                        delete (s, 1, p);
                    end;

                p := pos ('M', s);
                if p > 0 then
                    begin
                        infoFilme.duracao := infoFilme.duracao +
                                             60 * strToInt(copy (s, 1, p-1));
                        delete (s, 1, p);
                    end;

                p := pos ('S', s);
                if p > 0 then
                    begin
                        infoFilme.duracao := infoFilme.duracao +
                                             strToInt(copy (s, 1, p-1));
                        delete (s, 1, p);
                    end;
            except
                infoFilme.duracao := 0;
            end;

            if InformaAsVisualizacoes = true then
            infoFilme.visualizacoes := infos.O[0]['statistics']['viewCount'].AsInteger;
        end;
            infofilme.conteudo := infos.O[0]['snippet']['description'].AsString;
infofilme.            conteudo := utf8toansi(infofilme.conteudo);
    result := infoFilme;
end;

{--------------------------------------------------------}

procedure atualizaYoutubedl;
var
    nomeProg: string;
    salvaDir, dirExecVoxtube: string;
begin
                mensagem ('VTVERATU', 1);   {'Verificando atualizao do Youtube-dl'}
        getDir (0, salvaDir);
    dirExecVoxtube := (sintambiente('DOSVOX','PGMDOSVOX'));
    chdir (dirExecVoxtube);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\wget');
            if executaProg(nomeProg, '', '-N --unlink http://yt-dl.org/downloads/latest/youtube-dl.exe') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTVTJAATUA', 1);   {'Youtube-dl j est atualizado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
                end;

{--------------------------------------------------------}

procedure instalaTocadores;
var
    nomeProg, nome: string;
    salvaDir, dirExecVoxtube: string;
    arqOut: file;
    i1, i2, i3, i4, i5, i6, i7: integer;
begin


    i1 := 0;
    i2 := 0;
    i3 := 0;
    i4 := 0;
    i5 := 0;
    i6 := 0;
    i7 := 0;
                mensagem ('VTVERTOC', 1);   {'Verificando instalao dos tocadores'}
        getDir (0, salvaDir);
    dirExecVoxtube  := sintambiente('DOSVOX','PGMDOSVOX');
    chdir (dirExecVoxtube);
begin
nome := (dirExecVoxtube + '\' + 'ffplay.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i1:= 1
    else
    begin
                mensagem ('VTBAIPRI', 1);   {'Instalando o tocador 1 - ffplay'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador1.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC1INS', 1);   {'Tocador 1 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'mpc-hc\mpc-hc.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i2:= 1
    else
    begin
                mensagem ('VTBAISEG', 1);   {'Instalando o tocador 2 - mpc-hc'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador2.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC2INS', 1);   {'Tocador 2 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'potplayerportable\PotPlayerPortable.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i3:= 1
    else
    begin
                mensagem ('VTBAITER', 1);   {'Instalando o tocador 3 - PotPlayerPortable'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador3.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC3INS', 1);   {'Tocador 3 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'vlc\vlc.exe ');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i4:= 1
    else
    begin
                mensagem ('VTBAIQUA', 1);   {'Instalando o tocador 4 - vlc'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador4.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC4INS', 1);   {'Tocador 4 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'kmplayer\KMPlayer.exe ');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i5:= 1
    else
    begin
                mensagem ('VTBAIQUI', 1);   {'Instalando o tocador 5 - KMPlayer'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador5.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC5INS', 1);   {'Tocador 5 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'mpc-be\mpc-be.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i6:= 1
    else
    begin
                mensagem ('VTBAISEX', 1);   {'Instalando o tocador 6 - mpc-be'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador6.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC6INS', 1);   {'Tocador 6 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
begin
nome := (dirExecVoxtube + '\' + 'gomplayer\GOM.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    i7:= 1
    else
    begin
                mensagem ('VTBAISET', 1);   {'Instalando o tocador 7 - GOMPlayer'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\tocador7.exe');
            if executaProg(nomeProg, '', '') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOC7INS', 1);   {'Tocador 7 instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
                end;
end;
end;
    if (i3 = 0) or (i4 = 0) or (i5 = 0) or (i6 = 0) or (i7 = 0) then
    begin
                mensagem ('VTTOCINS', 1)   {'Os tocadores esto instalados'}
end
    else
    begin
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTTOCINS', 1);   {'Tocadores j esto instalados'}
end;
end;

{--------------------------------------------------------}

procedure atualizaVoxtube;
var
    nome, nomeProg: string;
    salvaDir, dirExecVoxtube: string;
    arqOut: file;

begin

                mensagem ('VTVATUAL', 1);   {'Verificando atualizao do Voxtube'}
        getDir (0, salvaDir);
    dirExecVoxtube := (sintambiente('DOSVOX','PGMDOSVOX'));
    chdir (dirExecVoxtube);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\atualiza');
                    begin
            if executaProg(nomeProg, '', '') then
                    esperaProgVoltar;
            if comEfeitos = true then
            begin
    sintsom ('msn_switching');
                mensagem ('VTATUALIZADO', 1);   {'Voxtube tambm j est atualizado'}
            end
            else
                mensagem ('VTATUALIZADO', 1);   {'Voxtube tambm j est atualizado'}
                mensagem ('VTVERFFM', 1);   {'Verificando instalao do ffmpeg'}
nome := (dirExecVoxtube  + '\' + 'ffmpeg.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult <> 0 then
    begin
            if comEfeitos = true then
                mensagem ('VTINSFFM', 1);   {'Instalando o ffmpeg'}
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\atuffmpeg');
            if executaProg(nomeProg, '', '') then
                    esperaProgVoltar;
                    end;
            if comEfeitos = true then
    sintsom ('msn_switching');
                mensagem ('VTFFMINS', 1);   {'ffmpeg j est instalado'}
                    while keypressed do readkey;
    chdir (salvaDir);
instalaTocadores;
                end;
                end;

{--------------------------------------------------------}
{ salva o audio do vdeo direto em formato mp3}
{--------------------------------------------------------}

procedure extraiaudioMp3(infofilme: tinfofilme);
var
    arquivo, diretorio: string;
    dirVideos: shortstring;
    c: char;
link : string;
arq : text;
x, y : string;
comclek : boolean;
debug: boolean;
begin
    debug := false;
x := '';
y := '';

    arquivo := subsCaracInvalidos (infoFilme.titulo + '.MP3');
link :=  linkReal(infoFilme.paginaweb);
    mensagem ('VTSALVP', 0);  {'Salvando para: '}
    sintWriteln (arquivo);
    writeln;
    mensagem ('VTEDITE', 1);  {'Editore o nome, tecle enter para confirmar, esc para cancelar.'}
    c := sintEditacampo(arquivo, wherex, wherey, 200, 80, true);
    if (c = ESC) or (arquivo = '') then
        begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            exit;
        end;

    writeln (arquivo);

    dirVideos := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));

        if (pos ('\', arquivo) = 0) and (pos ('/', arquivo) = 0) and
           (diretorio = '') and (dirVideos <> '') then
            arquivo := dirVideos + '\' + arquivo
        else
        if (pos ('\', arquivo) = 0) and (pos ('/', arquivo) = 0) and
           (diretorio <> '') then
            arquivo := diretorio + '\' + arquivo;

    if fileExists(arquivo) then
         begin
              mensagem ('VTARQEXI', 0);  {'Este arquivo j existe. Sobrescreve?'}
              c := upcase(sintReadkey);
              writeln (c);
            if (c <> 'S') and (c <> ENTER) then
                 begin
                    mensagem ('VTDESIST', 1);  {'Desistiu'}
                    exit;
                 end;
         end;
    writeln;

comclek := false;
            mensagem('VTGERAN', 1); {'Gerando MP3: '}
if debug then
begin
assign(arq,'teste.txt');
rewrite(arq);
end;
    appexecute ( sintambiente('DOSVOX','PGMDOSVOX')+'\ffmpeg -i "'+link+'" -ab '+
sintambiente('VOXTUBE','AUDIOBITRATE')+' -ac '+
sintambiente('VOXTUBE','AUDIOCHANELS')+' -ar '+
sintambiente('VOXTUBE','AUDIORESAMPLE')+
' -y "'+arquivo+'"');
    Delay(500);
x := appgetout;
x := appgetout;
    Repeat
    if not keypressed then
begin
x := appgetout;
delay(500);
    if (x <> y) and (comclek) then sintclek;
    y := x;
if debug then writeln(arq,x);
end
else
begin
c := readkey;
    if c = ENTER then
begin
x := appgetout;
                        mensagem ('VTRECEBI', 1);  {'Recebidos: '}
x := copy(x,10,pos('kB',x)-10);

if x <> '' then
Sintwriteln(x)
else
Sintwriteln('0');

                        mensagem ('VTKB', 1);  {' Kbytes'}

                        mensagem ('VTARQUIV', 1);  {' Arquivo: '}
sintwriteln(arquivo);
end;
    if c = #32 then comclek := not comclek;
    if c = esc then
Begin
            mensagem('VTDESPDL', 1); {'Deseja parar o download?'}
    c := sintreadkey;
    if (upcase(c) = 'S') or (upcase(c) = ESC) then
begin
    appsendstring('q');
    appstop;
if debug then closefile(arq);
            mensagem('VTDLINTR', 1); {'O download foi interrompido.'}
Exit;
end;
end;
end;
until pos('video:0kB',x) > 0;
            if comEfeitos = true then
    sintsom ('msn_switching');
                    mensagem ('VTOK', 1);  {'Ok!'}
            mensagem('VTXTAOK', 1); {'Extrao de udio concluda!'}
end;

{--------------------------------------------------------}
{ salva o audio do vdeo em formato mp4 e em seguida converte para mp3}
{--------------------------------------------------------}

procedure extraiaudio(infofilme: TInfoFilme);
var
    arqmp4, arqmp3 : file;
    nomevideo, nomeaudio, link, diretorio: string;
    dirVideos: shortstring;
    c: char;
    x, y : longint;
    comclek : boolean;
    prog, params: string;
    audioBitRate, audioChannels, audioResample: string;

label denovo;
begin
    nomeaudio := subsCaracInvalidos (infoFilme.titulo + '.MP3');
    nomevideo := subsCaracInvalidos (infoFilme.titulo + '.MP4');
    link := linkReal(infoFilme.paginaweb);

    mensagem ('VTSALVP', 0);  {'Salvando para: '}
    sintWriteln (nomeaudio);
    writeln;

    mensagem ('VTEDITE', 1);  {'Editore o nome, tecle enter para confirmar, esc para cancelar.'}
                    textBackground (BLACK);
    c := sintEditacampo(nomeaudio, wherex, wherey, 200, 80, true);
                    textBackground (RED);
    if (c = ESC) or (nomeaudio = '') then
        begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            exit;
        end;

    writeln (nomeaudio);

    dirVideos := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));

        if (pos ('\', nomeVideo) = 0) and (pos ('/', nomeVideo) = 0) and
           (diretorio = '') and (dirVideos <> '') then
            nomeVideo := dirVideos + '\' + nomeVideo
        else
        if (pos ('\', nomeVideo) = 0) and (pos ('/', nomeVideo) = 0) and
           (diretorio <> '') then
            nomeVideo := diretorio + '\' + nomeVideo;

        if (pos ('\', nomeAudio) = 0) and (pos ('/', nomeAudio) = 0) and
           (diretorio = '') and (dirVideos <> '') then
            nomeAudio := dirVideos + '\' + nomeAudio
        else
        if (pos ('\', nomeAudio) = 0) and (pos ('/', nomeAudio) = 0) and
           (diretorio <> '') then
            nomeAudio := diretorio + '\' + nomeAudio;

    if fileExists(nomeaudio) then
        begin
            mensagem ('VTARQEXI', 0);  {'Este arquivo j existe. Sobrescreve?'}
            c := upcase(sintReadkey);
            writeln (c);
            if (c <> 'S') and (c <> ENTER) then
                begin
                    mensagem ('VTDESIST', 1);  {'Desistiu'}
                    exit;
                end;
        end;

    writeln;

    comclek := false;

    mensagem ('VTBAIXVD', 1); {'baixando o vdeo, aguarde'}
    if download(link, nomevideo, false,'') then
        begin
            prog := sintambiente('DOSVOX','PGMDOSVOX') + '\ffmpeg.exe';

            audioBitRate := sintAmbiente('VOXTUBE','AUDIOBITRATE');
            if audioBitRate = '' then audioBitRate := '128000';

            audioChannels := sintAmbiente('VOXTUBE','AUDIOCHANELS');
            if audioChannels = '' then audioChannels := '2';

            audioResample :=    sintAmbiente('VOXTUBE','AUDIORESAMPLES');
            if audioResample = '' then audioResample := '44100';

            params :=
                 '-i "' + nomevideo + '"' +
                ' -ab ' + audioBitRate +
                ' -ac ' + audioChannels +
                ' -ar ' + audioResample +
                ' -y "' + nomeaudio + '"';

            assignfile(arqmp4,nomevideo);
            assignfile(arqmp3,nomeaudio);
            executaProgEx (prog, '', params, sw_hide);
        end
    else
        begin
            mensagem ('VTNAOCVA', 1); {'No consegui obter o vdeo para gerar o audio.'}
            mensagem ('VTOPCANC', 0);  {'Operao foi cancelada.'}
            exit;
        end;

    mensagem ('VTINCVMP', 1);  {'Iniciando converso para mp3.'}
            mensagem('VTGERAN', 1); {'Gerando MP3: '}
    while sintFalando do
        waitMessage;

    reset (arqmp3, 1);

    y := 0;
    repeat
        x := filesize(arqmp3);
        if comClek and (x <> y) then sintClek;

        if keypressed then
            begin
                c := readkey;
                if c = ENTER then
                    begin
                        mensagem ('VTCONVER', 1);  {'Convertidos: '}
                        if x >= 1024 then
                            begin
                                x := x div 1024;
                        sintWriteLn(inttostr(x));
                        mensagem ('VTKB', 1);  {' Kbytes'}
                            end
                        else
                        begin
                        sintWriteLn(inttostr(x));
                        mensagem ('VTBYTES', 1);  {' Bytes'}
                        end;

                        mensagem ('VTARQUIV', 1);  {' Arquivo: '}
                        sintWriteln (nomeaudio);
                    end
                else
                if c = #32 then   // letras comuns
                    comclek := not comclek
                else
                if c = ESC then
                    begin
                        mensagem ('VTPARACV', 0);  {'Deseja parar a converso?'}
                        c := sintReadkey;
                        writeln (c);
    if (upcase(c) = 'S') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
                            begin
                                executaProgEx ('taskKill','','/f /im ffmpeg.exe', sw_hide);
                                mensagem ('VTXACANC', 2); {'Extrao de udio foi cancelada.'}
                                exit;
                            end;
                    end;
            end;

        y := x;
        delay(500);

    until (not processExists('ffmpeg.exe'));

            if comEfeitos = true then
    sintsom ('msn_switching');
    mensagem ('VTXTAOK', 2);  {'Extrao de udio concluda!'}

    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if (confApaga = '') and (confApaga <> 'S') and (confApaga <> 'N') then
begin
    denovo:
    mensagem ('VTAPAORI', 2);  {'Apago o arquivo MP4 original? '}
              c := upcase(sintReadkey);
              writeln (c);
    if (upCase(c) = 'N') or (upCase(c) = BAIX) or (upcase(c) = ESC) then
    begin
                    mensagem ('VTOK', 1);  {'Ok!'}
            mensagem('VTNAOAPA', 1); {'No apaguei'}
    close(arqmp3);
                 exit;
                 end;
    if upCase(c) = 'S' then
                 begin
    erase(arqmp4);
                    mensagem ('VTOK', 1);  {'Ok!'}
            mensagem('VTAPAGUE', 1); {'Apaguei'}
    close(arqmp3);
                 exit;
                 end;
    goto denovo;
end;

    if apagaArqMp4 = true then
    begin
    erase(arqmp4);
                    mensagem ('VTOK', 1);  {'Ok!'}
            mensagem('VTAPAGUE', 1); {'Apaguei'}
    close(arqmp3);
                 exit;
                 end
                 else
            if apagaArqMp4 = false then
                 begin
                    mensagem ('VTOK', 1);  {'Ok!'}
            mensagem('VTNAOAPA', 1); {'No apaguei'}
    close(arqmp3);
                 exit;
                 end;
end;

{--------------------------------------------------------}
{ Indicando as letras das memrias
{--------------------------------------------------------}

procedure letrasNaMemoria;
begin
        mensagem ('VTMEMLET', 0);  {'Folheando as memrias da letra '}
if letraMemoria = 'A' then
sintSom ('_65');
if letraMemoria = 'B' then
sintSom ('_66');
if letraMemoria = 'C' then
sintSom ('_67');
if letraMemoria = 'D' then
sintSom ('_68');
if letraMemoria = 'E' then
sintSom ('_69');
if letraMemoria = 'F' then
sintSom ('_70');
if letraMemoria = 'G' then
sintSom ('_71');
if letraMemoria = 'H' then
sintSom ('_72');
if letraMemoria = 'I' then
sintSom ('_73');
if letraMemoria = 'J' then
sintSom ('_74');
if letraMemoria = 'K' then
sintSom ('_75');
if letraMemoria = 'L' then
sintSom ('_76');
if letraMemoria = 'M' then
sintSom ('_77');
if letraMemoria = 'N' then
sintSom ('_78');
if letraMemoria = 'O' then
sintSom ('_79');
if letraMemoria = 'P' then
sintSom ('_80');
if letraMemoria = 'Q' then
sintSom ('_81');
if letraMemoria = 'R' then
sintSom ('_82');
if letraMemoria = 'S' then
sintSom ('_83');
if letraMemoria = 'T' then
sintSom ('_84');
if letraMemoria = 'U' then
sintSom ('_85');
if letraMemoria = 'V' then
sintSom ('_86');
if letraMemoria = 'W' then
sintSom ('_87');
if letraMemoria = 'X' then
sintSom ('_88');
if letraMemoria = 'Y' then
sintSom ('_89');
if letraMemoria = 'Z' then
sintSom ('_90');
end;

{--------------------------------------------------------}
{                   Apagando as dez ltimas buscas gravadas na memria
{--------------------------------------------------------}

procedure limpaMemoria;
var memoria: string;
    sz: array [0..144] of char;
    c: char;

label denovo;
begin
    repeat

    denovo:
        mensagem('VTDIGMEM', 1); {'Digite a memria de 1 a 0, ou tecle T para limpar todas'}
    c := sintreadkey;
    sintCarac (c);
        writeln (c);

    if not (upCase(c) in['0'..'9', 'T']) and (upcase(c) <> BAIX) and (upcase(c) <> ESC) then
    goto denovo;
    until (upCase(c) in['0'..'9', 'T']) or (upcase(c) = BAIX) or (upcase(c) = ESC);

    begin
    if upCase(c) = '1' then
//    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '0')), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '0'), sz, 'DOSVOX.INI');
    if upCase(c) = '2' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '1'), sz, 'DOSVOX.INI');
    if upCase(c) = '3' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '2'), sz, 'DOSVOX.INI');
    if upCase(c) = '4' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '3'), sz, 'DOSVOX.INI');
    if upCase(c) = '5' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '4'), sz, 'DOSVOX.INI');
    if upCase(c) = '6' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '5'), sz, 'DOSVOX.INI');
    if upCase(c) = '7' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '6'), sz, 'DOSVOX.INI');
    if upCase(c) = '8' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '7'), sz, 'DOSVOX.INI');
    if upCase(c) = '9' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '8'), sz, 'DOSVOX.INI');
    if upCase(c) = '0' then
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '9'), sz, 'DOSVOX.INI');
    writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO', sz, 'DOSVOX.INI');
        mensagem ('VTOK', 1);  {'Ok!'}

    begin
    if upCase(c) = 'T' then
    begin
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '0'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '1'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '2'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '3'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '4'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '5'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '6'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '7'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '8'), sz, 'DOSVOX.INI');
    writePrivateProfileString('VOXTUBE', pchar('C' + letraMemoria + '9'), sz, 'DOSVOX.INI');
    writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO', sz, 'DOSVOX.INI');
    exit;
    end;

    if (upCase(c) in['0'..'9']) then
    repeat
        mensagem('VTDESLMA', 1); {'Deseja limpar mais alguma? '}
    c := sintreadkey;
        writeln (c);
    if (upcase(c) = 'S') and (upcase(c) <> 'N') and (upcase(c) <> BAIX) and (upcase(c) <> ESC) then
    goto denovo;
    until (upcase(c) = 'S') or (upcase(c) = 'N') or  (upcase(c) = BAIX) or (upcase(c) = ESC);
    end;
    end;

    if (upCase(c) = 'N') or (upCase(c) = BAIX) or (upcase(c) = ESC) then
    begin
        mensagem ('VTCNTFOL', 1);  {'Continue folheando ou tecle ESC'}
    exit;
    end;
end;

{--------------------------------------------------------}
{                     salva o filme
{--------------------------------------------------------}

procedure salvaFilme (infoFilme: TInfoFilme);
var
    nomeVideo, diretorio: string;
    dirVideos: shortstring;
    c: char;
    link: string;

begin
    nomeVideo := subsCaracInvalidos (infoFilme.titulo + '.MP4');
    link := linkReal(infoFilme.paginaweb);
    if link = '' then
        begin
            mensagem ('VTDECERR', 1);  {'No  possvel baixar esse vdeo. Sinto muito.'}
            exit;
        end;

    mensagem ('VTSALVP', 0);  {'Salvando para: '}
    sintWriteln (nomeVideo);
    writeln;

    mensagem ('VTEDITE', 1);  {'Editore o nome, tecle enter para confirmar, esc para cancelar.'}
                    textBackground (BLACK);
    c := sintEditacampo(nomeVideo, wherex, wherey, 200, 80, true);
                    textBackground (RED);
    if (c = ESC) or (nomeVideo = '') then
        begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            exit;
        end;

    writeln (nomeVideo);

    dirVideos := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));

        if (pos ('\', nomeVideo) = 0) and (pos ('/', nomeVideo) = 0) and
           (diretorio = '') and (dirVideos <> '') then
            nomeVideo := dirVideos + '\' + nomeVideo
        else
        if (pos ('\', nomeVideo) = 0) and (pos ('/', nomeVideo) = 0) and
           (diretorio <> '') then
            nomeVideo := diretorio + '\' + nomeVideo;

    if fileExists(nomeVideo) then
         begin
              mensagem ('VTARQEXI', 0);  {'Este nomeVideo j existe. Sobrescreve?'}
              c := upcase(sintReadkey);
              writeln (c);
            if (c <> 'S') and (c <> ENTER) then
                 begin
                    mensagem ('VTDESIST', 1);  {'Desistiu'}
                    exit;
                 end;
         end;

    writeln;

    mensagem ('VTBAIXVD', 1); {'Baixando o vdeo, aguarde.'}
    if download(link, nomeVideo, false,'') then
begin
            if comEfeitos = true then
    sintsom ('dindondin');
        mensagem ('VTOK', 1);  {'Ok!'}
        end
    else
        begin
            mensagem ('VTNAOCVA', 1); {'No consegui obter o vdeo para gerar o audio.'}
            mensagem ('VTOPCANC', 0);  {'Operao foi cancelada.'}
            exit;
        end;
end;

{-------------------------------------------------------------}

Procedure MolduraTela;
var j: byte;
begin
textcolor(white);
gotoxy(1,1);
write('+');
for j:=2 to 79 do write('-');
write('+', '');
for J:=1 to 23  do
  begin
  gotoxy(80, j+1);
  write('', '');
  end;
gotoxy(1,25);
write('+');
For j:=2 to 79  Do write('-');
gotoxy(1,6);
write('+');
for j:=2 to 79 do write('-');
write('');
gotoxy(1,23); write('+');
for j:=2 to 79  do write('-');
write('');
{mem[$B800:3998]:=217;}
textcolor(lightgray);
end;

{-------------------------------------------------------------}

Procedure Escrevetela;
begin
  textbackground(blue);
  textcolor (LightGray);
  Clrscr;
  MolduraTela;
  gotoxy(26,2);
  write( 'Programa VOXTUBE');
  gotoxy(29, 3);
  write ('Verso VOXTUBE 2.4g Glauco 15.4 atualizada em 6 de outubro de 2017');
  gotoxy(6, 4);
  Write(' Autores: Fabiano Ferreira');
  gotoxy(6, 5);
  write('           Professor Antonio Borges');
  gotoxy(6, 6);
  write('           Aperfeioado por Glauco Frius')
end;

{-------------------------------------------------------------}

function primeiraLetra (s: string): char;
begin
    s := trim (s);
    delete (s, 2, 999);
    if s = '' then primeiraLetra := ' '
              else primeiraLetra := upcase (s[1]);
end;

{-------------------------------------------------------------}

function existeDir (dir: string): boolean;
var dirAtual: string;
begin
    getDir (0, dirAtual);
    {$I-}  chdir (dir);  {$I+}
    existeDir := ioresult = 0;
    chdir (dirAtual);
end;

{-------------------------------------------------------------}
{       consiste nome de diretrio da configurao
{-------------------------------------------------------------}

procedure consisteDirArq;
var erro: boolean;
    c, c2: char;
    confDirVideos: shortString;
    s: string;
    sz: array [0..144] of char;
    dirAtual: string;
begin
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    erro := false;
    if not existeDir (confDirVideos) then
        begin
            mensagem ('VTERDGRA', 1); {'Ateno! Diretrio de gravao inexistente'}
            sintWriteLn (confDirVideos);
            mensagem ('VTPOSCRI', 1);   {'Posso cri-lo? '}
            sintLeTecla (c, c2);
            writeln;
            if upcase(c) = 'N' then
                erro := true
            else
                begin
                     {$I-}  mkdir (confDirVideos);  {$I+}
                     if ioresult <> 0 then
                         begin
                             erro := true;
                             mensagem ('VTDGNCRI', 1); {'Diretrio no foi criado.'}
                         end;
                end;
        end;

    if erro then
begin
         mensagem ('VTASDACI', 1);  {'Assumindo o diretrio de acionamento'}
    getDir (0, dirAtual);
         sintWriteLn (dirAtual);

            s := '.';
            strPCopy (sz, s);
            writePrivateProfileString('VOXTUBE', 'DIRVIDEOS',     sz, 'DOSVOX.INI');
end;
end;

{-----------------------------}

procedure consisteDirVideos;
var erro: boolean;
    c, c2: char;
    confDirVideos: shortString;
    s: string;
    sz: array [0..144] of char;
    dirAtual: string;
begin
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    erro := false;
    if not existeDir (confDirVideos) then
        begin
            mensagem ('VTERDGRA', 1); {'Ateno! Diretrio de gravao inexistente'}
            sintWriteLn (confDirVideos);
            mensagem ('VTPOSCRI', 1);   {'Posso cri-lo? '}
            sintLeTecla (c, c2);
            writeln;
            if upcase(c) = 'N' then
                erro := true
            else
                begin
                     {$I-}  mkdir (confDirVideos);  {$I+}
                     if ioresult <> 0 then
                         begin
                             erro := true;
                             mensagem ('VTDGNCRI', 1); {'Diretrio no foi criado.'}
                         end;
                end;
        end;

    if erro then
begin
         mensagem ('VTASDACI', 1);  {'Assumindo o diretrio de acionamento'}
    getDir (0, dirAtual);
         sintWriteLn (dirAtual);

            s := '.';
            strPCopy (sz, s);
            writePrivateProfileString('VOXTUBE', 'DIRVIDEOS',     sz, 'DOSVOX.INI');
end;
end;

{--------------------------------------------------------}

procedure configurando;
var confSapi: shortString;
     velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
    comSapi: boolean;
    s: string;
    erro : Integer;
    dirGravaBuscas: boolean;
begin
    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4  then
begin
  apagaArqMp4 :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4 then
begin
  apagaArqMp4:=true;
end;

    s := sintAmbiente ('VOXTUBE', 'DIRVIDEOS');
    if s = '' then
    begin
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) = 'N';
    end
    else
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) <> 'N';
        if dirGravaBuscas then
begin
end;

    if confSapi = '' then
        comSapi := primeiraLetra (sintAmbiente ('VOXTUBE', 'SAPIATIVADO')) = 'S'
    else
        comSapi := primeiraLetra (confSapi) = 'S';

            val (sintAmbiente('VOXTUBE', 'NUMEROSAPI'), confNum, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'VOZ'), confNum, erro);
            if erro <> 0 then confNum := 1;

            val (sintAmbiente('VOXTUBE', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then confTipoSapi := 3;

            val (sintAmbiente('VOXTUBE', 'VELOCIDADESAPI'), confVeloc, erro);
            if erro <> 0 then confVeloc:= 0;
            val (sintAmbiente('VOXTUBE', 'TONALIDADESAPI'), confTonal, erro);
            if erro <> 0 then confTonal:= 0;

                    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 0
    else
        val (s, velGeral, erro);
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);

    writeln;
    escreveTela;
end;

{--------------------------------------------------------}

procedure formConfig;
var confTocador0, confTocador1, confTocador2, confTocador3, confTocador4, confTocador5, confTocador6, confTocador7, confPag, confGra, confInfToc, confAciEfe, confAtualiza, confDirVideos,
    confSapi, confAudiobitrate, confAudioresample, confAudiochanels: shortString;
     velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
    parm: array [0..255] of char;
    comSapi: boolean;
    i: integer;
    s: string;
    erro : Integer;
    dirGravaBuscas: boolean;

begin

    //Recuperando informaes do DOSVOX.INI

    val (sintAmbiente('VOXTUBE', 'VELOCIDADE'), velGeral, erro);
    if erro <> 0 then velGeral := 0;
    confPag  := (sintAmbiente('VOXTUBE', 'VIDEOSPORPAGINA'));
    confInfToc  := (sintAmbiente('VOXTUBE', 'INFORMATOCADOR'));
    if (confInfToc = 'S') or (confInfToc = 'SIM') then confInfToc := 'SIM' else confInfToc := 'NO';
    confAciEfe  := (sintAmbiente('VOXTUBE', 'ACIONAEFEITOS'));
    if (confAciEfe = 'S') or (confAciEfe = 'SIM') then confAciEfe := 'SIM' else confAciEfe := 'NO';
    confAtualiza  := (sintAmbiente('VOXTUBE', 'ATUALIZA'));
    if (confAtualiza = 'S') or (confAtualiza = 'SIM') then confAtualiza := 'SIM' else confAtualiza := 'NO';
    confGra  := (sintAmbiente('VOXTUBE', 'GRAVABUSCA'));
    if (confGra = 'S') or (confGra = 'SIM') then confGra := 'SIM' else confGra := 'NO';
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if (confApaga = 'S') or (confApaga = 'SIM') then confApaga := 'SIM' else confApaga := 'NO';

    confSapi       := (sintAmbiente('VOXTUBE', 'SAPIATIVADO'));
    if (confSapi = 'S') or (confSapi = 'SIM') then confSapi := 'SIM' else confSapi := 'NO';

    val (sintAmbiente('VOXTUBE', 'TIPOSAPI'), confTipoSapi, erro);
    if erro <> 0 then val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
    if erro <> 0 then confTipoSapi := 4;

    val (sintAmbiente('VOXTUBE', 'NUMEROSAPI'), confNum, erro);
    if erro <> 0 then confNum:= 1;

    val (sintAmbiente('VOXTUBE', 'VELOCIDADESAPI'), confVeloc, erro);
    if erro <> 0 then confVeloc:= 0;
    val (sintAmbiente('VOXTUBE', 'TONALIDADESAPI'), confTonal, erro);
    if erro <> 0 then confTonal:= 0;

    confAudiobitrate  := (sintAmbiente('VOXTUBE', 'AUDIOBITRATE'));
    confAudioresample  := (sintAmbiente('VOXTUBE', 'AUDIORESAMPLE'));
    confAudiochanels  := (sintAmbiente('VOXTUBE', 'AUDIOCHANELS'));

    confTocador0 := (sintAmbiente('VOXTUBE', 'TOCADOR0'));
    confTocador1 := (sintAmbiente('VOXTUBE', 'TOCADOR1'));
    confTocador2 := (sintAmbiente('VOXTUBE', 'TOCADOR2'));
    confTocador3 := (sintAmbiente('VOXTUBE', 'TOCADOR3'));
    confTocador4 := (sintAmbiente('VOXTUBE', 'TOCADOR4'));
    confTocador5 := (sintAmbiente('VOXTUBE', 'TOCADOR5'));
    confTocador6 := (sintAmbiente('VOXTUBE', 'TOCADOR6'));
    confTocador7 := (sintAmbiente('VOXTUBE', 'TOCADOR7'));

    // Apresentando o formulrio

    textBackground (BLUE);
    writeln;
    mensagem ('VTPAICON', 1); {'Painel de configurao'}
    sintBip; sintBip;
    textBackground (BLACK);
    for i := 10 to 29 do
        begin
             gotoxy (1, i);  clreol;
        end;
    gotoxy (1, 10);

    formCria;
    formCampoInt ('VTVELC',   pegaTextoMensagem ('VTVELC')   {'Velocidade: '},         velGeral); {''}
    formCampo    ('VTVIDPAG', pegaTextoMensagem ('VTVIDPAG') {'Vdeos por pgina: '},    confPag, 2); {''}
    formCampo    ('VTINFTOC', pegaTextoMensagem ('VTINFTOC') {'Informa o tocador? '},    confInfToc, 4); {'Informa o tocador? '}
    formCampo    ('VTACIEFE', pegaTextoMensagem ('VTACIEFE') {'Aciona efeitos? '},    confAciEfe, 4); {''}
    formCampo    ('VTFAZATU', pegaTextoMensagem ('VTFAZATU') {'Inicia atualizando o Youtube-dl e o Voxtube?'},    confAtualiza, 4); {''}
    formCampo    ('VTGRABUS', pegaTextoMensagem ('VTGRABUS') {'Grava busca? '},    confGra, 4); {''}
    formCampo    ('VTDIRVID', pegaTextoMensagem ('VTDIRVID') {'Diretrio de gravao dos vdeos: '},    confDirVideos, 80); {''}
    formCampo    ('VTAPAORI', pegaTextoMensagem ('VTAPAORI') {'Apaga mp4 original? '},    confApaga, 4); {''}
    formCampo    ('VTCOMSAP', pegaTextoMensagem ('VTCOMSAP') {'Com SAPI? '},           confSapi, 4); {''}
    formCampoInt ('VTTIPSAP', pegaTextoMensagem ('VTTIPSAP') {'Tipo SAPI, 3, 4 ou 5?: '}, confTipoSapi); {''}
    formCampoInt ('VTNUMSAP', pegaTextoMensagem ('VTNUMSAP') {'Nmero SAPI: '},        confNum); {''}
    formCampoInt ('VTVEL',    pegaTextoMensagem ('VTVEL')    {'Velocidade SAPI: '},    confVeloc); {''}
    formCampoInt ('VTTOM',    pegaTextoMensagem ('VTTOM')    {'Tonalidade SAPI: '},    confTonal); {''}
    formCampo    ('VTQUALID', pegaTextoMensagem ('VTQUALID') {'Qualidade do udio: '},    confAudiobitrate, 7); {''}
    formCampo    ('VTTAXAMO', pegaTextoMensagem ('VTTAXAMO') {'Digite a taxa de amostragem, altera a afinao e a durao do udio: '},    confAudioresample, 8);
{''}
    formCampo    ('VTMONSTE', pegaTextoMensagem ('VTMONSTE') {'Digite 1 para Mono e 2 para  estreo: '},    confAudiochanels, 1); {''}
    formCampo    ('VTTOCENT', pegaTextoMensagem ('VTTOCENT') {'Tocador 0 para o ENTER: '},    confTocador0, 80); {''}
    formCampo    ('VTTOCACR', pegaTextoMensagem ('VTTOCACR') {'Tocador 1 para o cedilha: '},    confTocador1, 80); {''}
    formCampo    ('VTTOCADX', pegaTextoMensagem ('VTTOCADX') {'Tocador 2 para o X: '},    confTocador2, 80); {''}
    formCampo    ('VTTOCACX', pegaTextoMensagem ('VTTOCACX') {'Tocador 3 para o CTRL+X: '},    confTocador3, 80); {''}
    formCampo    ('VTTOCADV', pegaTextoMensagem ('VTTOCADV') {'Tocador 4 para o V: '},    confTocador4, 80); {''}
    formCampo    ('VTTOCACV', pegaTextoMensagem ('VTTOCACV') {'Tocador 5 para o CTRL+V: '},    confTocador5, 80); {''}
    formCampo    ('VTTOCADR', pegaTextoMensagem ('VTTOCADR') {'Tocador 6 para a Raiz: '},    confTocador6, 80); {''}
    formCampo    ('VTTOCADB', pegaTextoMensagem ('VTTOCADB') {'Tocador 7 para a Barra Vertical: '},    confTocador7, 80); {''}
    formEdita (true);

    //Efetuando modificaes

    if (velGeral < 0) or (velGeral > 5) then
        velGeral:= 0;

    // gravando DOSVOX.INI

        if confPag > intToStr(50) then
        confPag := intToStr(50);
        if confPag < intToStr(1) then
        confPag := intToStr(25);

        if confAudiochanels > intToStr(2) then
        confAudiochanels := intToStr(2);
        if confAudiochanels < intToStr(1) then
        confAudiochanels := intToStr(2);

    writePrivateProfileString ('VOXTUBE', 'VELOCIDADE', pchar(intToStr(velGeral)), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confPag));
    writePrivateProfileString ('VOXTUBE', 'VIDEOSPORPAGINA', (parm), 'DOSVOX.INI');

    strpCopy (parm, maiuscAnsi(confInfToc));
    writePrivateProfileString ('VOXTUBE', 'INFORMATOCADOR', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAciEfe));
    writePrivateProfileString ('VOXTUBE', 'ACIONAEFEITOS', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAtualiza));
    writePrivateProfileString ('VOXTUBE', 'ATUALIZA', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confGra));
    writePrivateProfileString ('VOXTUBE', 'GRAVABUSCA', (parm), 'DOSVOX.INI');
    strpCopy (parm, confDirVideos);
    writePrivateProfileString ('VOXTUBE', 'DIRVIDEOS', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confApaga));
    writePrivateProfileString ('VOXTUBE', 'MP4APAGA', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confSapi));
    writePrivateProfileString ('VOXTUBE', 'SAPIATIVADO', (parm), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'TIPOSAPI', pchar(intToStr(confTipoSapi)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'NUMEROSAPI', pchar(intToStr(confNum)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'VELOCIDADESAPI', pchar(intToStr(confVeloc)), 'DOSVOX.INI');
    writePrivateProfileString ('VOXTUBE', 'TONALIDADESAPI', pchar(intToStr(confTonal)), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudiobitrate));
    writePrivateProfileString ('VOXTUBE', 'AUDIOBITRATE', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudioresample));
    writePrivateProfileString ('VOXTUBE', 'AUDIORESAMPLE', (parm), 'DOSVOX.INI');
    strpCopy (parm, maiuscAnsi(confAudiochanels));
    writePrivateProfileString ('VOXTUBE', 'AUDIOCHANELS', (parm), 'DOSVOX.INI');

    strpCopy (parm, confTocador0);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR0', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador1);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR1', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador2);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR2', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador3);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR3', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador4);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR4', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador5);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR5', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador6);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR6', (parm), 'DOSVOX.INI');
    strpCopy (parm, confTocador7);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR7', (parm), 'DOSVOX.INI');

    consisteDirArq;
    consisteDirVideos;

    mensagem ('VTAGUARC', 1); {'Aguarde, configurando'}
    sintPara;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4  then
begin
  apagaArqMp4 :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4 then
begin
  apagaArqMp4:=true;
end;

    s := sintAmbiente ('VOXTUBE', 'DIRVIDEOS');
    if s = '' then
    begin
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) = 'N';
    end
    else
    dirGravaBuscas := copy (sintAmbiente ('VOXTUBE', 'DIRVIDEOS'), 1, 1) <> 'N';
        if dirGravaBuscas then
begin
end;

    if confSapi = '' then
        comSapi := primeiraLetra (sintAmbiente ('VOXTUBE', 'SAPIATIVADO')) = 'S'
    else
        comSapi := primeiraLetra (confSapi) = 'S';

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 0
    else
        val (s, velGeral, erro);
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);

    writeln;
        mensagem ('VTOK', 1); {'Ok!'}
    sintBip; sintBip; sintBip;
    escreveTela;
end;

{--------------------------------------------------------}

procedure selFala (nvoz: char);
var
    s: string;
    param: TParamVoz;
    velGeral, erro: integer;

    function extraiParam (var s: string): integer;
    var n: integer;
        negativo: integer;
    begin
        while (s <> '') and (s[1] = ' ') do delete (s, 1, 1);
        n := 0;

        negativo := 1;
        if (s <> '') and (s[1] = '-') then
            begin
                negativo := -1;
                delete (s, 1, 1);
            end;

        while (s <> '') and (s[1] in ['0'..'9']) do
            begin
                n := n * 10 + (ord(s[1]) - ord ('0'));
                delete (s, 1, 1);
            end;
        extraiParam := n * negativo;
    end;

begin
    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 0
    else
        val (s, velGeral, erro);

    if nvoz = 'N' then
        sintReinic (velGeral, false, 3, 1, 1, 1)
    else
        begin
            s := sintAmbiente ('SAPIUTIL', 'VOZ'+nvoz);
            with param do
                begin
                    voz        := extraiParam (s);
                    velocidade := extraiParam (s);
                    tom        := extraiParam (s);
                    tipoSapi   := extraiParam (s);
                    if tipoSapi = 0 then tipoSapi := 4;

                    sintReinic (velGeral, true, tipoSapi, voz, velocidade, tom);
                end;
        end;
end;

{--------------------------------------------------------}

procedure ajuda;
begin
    writeln;
    mensagem ('VTOPCAO', 1);  {'As opes so:'}
    mensagem ('VTOP_ENT', 1);  {'ENTER ou F5 - Executa o vdeo com o tocador interno'}
    mensagem ('VTOP_CTR', 1);  {' ou F12 - Executa o vdeo com o primeiro tocador'}
    mensagem ('VTOP_X', 1);  {'X ou F6 - Executa o vdeo com o segundo tocador'}
    mensagem ('VTOP_CTX', 1);  {'CTRL+X ou F7 - Executa o vdeo com o terceiro tocador'}
    mensagem ('VTOP_V', 1);  {'V ou CTRL+F5 - Executa o vdeo com o quarto tocador'}
    mensagem ('VTOP_CTV', 1);  {'CTRL+V ou CTRL+F6 - Executa o vdeo com o quinto tocador'}
    mensagem ('VTOP_RAI', 1);  {'Raiz ou CTRL+F7 - Executa o vdeo com o sexto tocador'}
    mensagem ('VTOP_BVT', 1);  {'Barra Vertical - Executa o vdeo com o stimo tocador'}
    mensagem ('VTOP_CTEN', 1);  {'CTRL+Enter - Exibe o vdeo com o navegador padro'}
    mensagem ('VTOP_H', 1);  {'H - Aciona efeitos'}
    mensagem ('VTOP_Y', 1);  {'Y e F2 - Atualizam o Voxtube, o Youtube-dl, o ffmpeg e os tocadores'}
    mensagem ('VTOP_Z', 1);  {'z - Muda a letra das memrias'}
    mensagem ('VTOP_ZZ', 1);  {'Z - Informa a letra das memrias'}
    mensagem ('VTOP_E', 1);  {'E - Apaga as memrias'}
    mensagem ('VTOP_F', 1);  {'F - Informa a posio na lista de vdeos'}
    mensagem ('VTOP_G', 1);  {'G ou CTRL+G - Ativa e desativa a gravao das buscas'}
    mensagem ('VTOP_O', 1);  {'O e CTRL+O - Ativa e desativa o apagamento do original em mp4'}
    mensagem ('VTOP_B', 1);  {'B - Faz download em mp4 de todos os vdeos marcados'}
    mensagem ('VTOP_CTB', 1);  {'CTRL+B - Faz download em vdeo de todos os vdeos marcados em vrios formatos'}
    mensagem ('VTSELTIP', 1);  {'J - Seleciona os tipos de downloads'}
    mensagem ('VTSELTOC', 1);  {'U - Seleciona os tipos de tocadores'}
    mensagem ('VTOP_K', 1);  {'K - Ativa e desativa a informao das  visualizaes do vdeo'}
    mensagem ('VTOP_CTK', 1);  {'CTRL+K - Informa o nmero de visualizaes do vdeo'}
    mensagem ('VTOP_M', 1);  {'M - Faz download do vdeo e depois converte de mp4 para mp3'}
    mensagem ('VTOP_N', 1);  {'N - Faz download em mp3 de todos os vdeos marcados'}
    mensagem ('VTOP_CTN', 1);  {'CTRL+N - Faz download em udio de todos os vdeos marcados em vrios formatos'}
    mensagem ('VTOP_I', 1);  {'I - Informaes sobre o vdeo'}
    mensagem ('VTOP_CTI', 1);  {'CTRL+I - Soletra informaes sobre o vdeo'}
    mensagem ('VTOP_P', 1);  {'P - Prxima pgina'}
    mensagem ('VTOP_CTP', 1);  {'CTRL+P - Vai para pgina'}
    mensagem ('VTOP_A', 1);  {'A - Pgina anterior'}
    mensagem ('VTOP_CTA', 1);  {'CTRL+A - Vai para pgina'}
    mensagem ('VTOP_Q', 1);  {'Q - Informa a posio na lista de vdeos, e o universo de vdeos'}
    mensagem ('VTOP_CTQ', 1);  {'CTRL+Q - Informa a pgina e o universo de pginas'}
    mensagem ('VTOP_R', 1);  {'R - Carrega a pgina do vdeo no Webvox'}
    mensagem ('VTOP_T', 1);  {'T e CTRL+T - Ativa e desativa a informao do tocador que ser utilizado'}
    mensagem ('VTOP_W', 1);  {'W - Informa o universo de vdeos'}
    mensagem ('VTOP_CTW', 1);  {'CTRL+W - Informa o universo de pginas'}
    mensagem ('VTOP_S', 1);  {'S - Faz download do vdeo em mp4'}
    mensagem ('VTOP_CTS', 1);  {'CTRL+S - Faz download em mp3 do audio do vdeo j convertido'}
    mensagem ('VTOP_CTL', 1);  {'CTRL+L - Copia o link do vdeo atual'}
    mensagem ('VTOP_CTC', 1);  {'CTRL+C ou CTRL+Z - Copia o ttulo e o link dos vdeos'}
    mensagem ('VTOP_CTD', 1);  {'CTRL+D - Copia as informaes sobre os vdeos'}
    mensagem ('VTOP_L', 1);  {'L - copia os links dos vdeos marcados, ou do atual'}
    mensagem ('VTOP_C', 1);  {'C - Informa o contedo do vdeo'}
    mensagem ('VTOP_D', 1);  {'d - Durao do vdeo'}
    mensagem ('VTOP_DD', 1);  {'D - Data e hora de publicao do vdeo'}
    mensagem ('VTOP_CDI', 1);  {'CTRL+DIREITA - Prxima pgina'}
    mensagem ('VTOP_CES', 1);  {'CTRL+Esquerda - Pgina anterior'}
    mensagem ('VTOP_CBA', 1);  {'CTRL+SETABAIXO - Vai para o vdeo'}
    mensagem ('VTOP_CCI', 1);  {'CTRL+SETACIMA - Informa o nmero do vdeo'}
    mensagem ('VTOP_DIR', 1);  {'DIREITA - Informa o nmero do vdeo e soletra o ttulo'}
    mensagem ('VTOP_ESQ', 1);  {'ESQUERDA - Informa a durao do vdeo e o ttulo'}
    mensagem ('VTOP_F2', 1);  {'F2 - Grava o vdeo em mp4'}
    mensagem ('VTOP_F3', 1);  {'F3 - Grava o audio do vdeo em mp3'}
    mensagem ('VTOP_F4', 1);  {'F4 - Painel de Configurao'}
    mensagem ('VTOP_CF1', 1);  {'CTRL+F1 - Velocidade 2'}
    mensagem ('VTOP_CF2', 1);  {'CTRL+F2 - Velocidade 3'}
    mensagem ('VTOP_CF3', 1);  {'CTRL+F3 - Velocidade 4'}
    mensagem ('VTOP_CF4', 1);  {'CTRL+F4 - Velocidade 5'}
    mensagem ('VTOP_F8', 1);  {'F8 - Fala a hora'}
    mensagem ('VTOP_CF8', 1);  {'CTRL+F8 - Fala a data'}
    mensagem ('VTOP_1A0', 1);  {'Teclando 1 a 9 ativa voz Sapi prconfigurada e 0 ativa voz nativa'}
    mensagem ('VTOP_PV', 1);  {'Ponto e vrgula - Fala a verso'}
    mensagem ('VTOP_ESC', 2);  {'ESC - Cancelar'}

    readkey;
    limpaBufTec;
end;

{--------------------------------------------------------}

procedure menuAdiciona (cod: string);
begin
    popupMenuAdiciona (cod, pegaTextoMensagem(cod));
end;

function selSetasOpcao: char;
var n: integer;
const
    opmenu: string = ^M+''+'X'+^X+'V'+^V+'\'+'|'+^J+'HYzZEFGOB'+^B+'JUMN'+^N+'I'+^I+'P'+^P+'A'+^A+'Q'+^Q+'RTW'+^W+'S'+^S+^L+^C+^D+'LCdD;'+#$1b;

begin

    mensagem ('VTSELSET', 2); {'Selecione com as setas a opo desejada:'}

    popupMenuCria(wherex, wherey, 50, 47, RED);
    menuAdiciona ('VTOP_ENT');  {'ENTER - Executa o vdeo com o tocador interno'}
    menuAdiciona ('VTOP_CTR');  {' - Executa o vdeo com o primeiro tocador'}
    menuAdiciona ('VTOP_X');  {'X - Executa o vdeo com o segundo tocador'}
    menuAdiciona ('VTOP_CTX');  {'CTRL+X - Executa o vdeo com o terceiro tocador'}
    menuAdiciona ('VTOP_V');  {'V - Executa o vdeo com o quarto tocador'}
    menuAdiciona ('VTOP_CTV');  {'CTRL+V - Executa o vdeo com o quinto tocador'}
    menuAdiciona ('VTOP_RAI');  {'Raiz - Executa o vdeo com o sexto tocador'}
    menuAdiciona ('VTOP_BVT');  {'Barra Vertical - Executa o vdeo com o stimo tocador'}
    menuAdiciona ('VTOP_CTEN');  {'CTRL+Enter - Exibe o vdeo com o navegador padro'}
    menuAdiciona ('VTOP_H');  {'Aciona efeitos'}
    menuAdiciona ('VTOP_Y');  {'Y e F2 - Atualizam o Voxtube, o Youtube-dl, o ffmpeg e os tocadores'}
    menuAdiciona ('VTOP_Z');  {'z - Muda a letra das memrias'}
    menuAdiciona ('VTOP_ZZ');  {'Z - Informa a letra das memrias'}
    menuAdiciona ('VTOP_E');  {'E - Apaga as memrias'}
    menuAdiciona ('VTOP_F');  {'F - Informa a posio na lista de vdeos'}
    menuAdiciona ('VTOP_G');  {'G ou CTRL+G - Ativa e desativa a gravao das buscas'}
    menuAdiciona ('VTOP_O');  {'O e CTRL+O - Ativa e desativa o apagamento do original em mp4'}
    menuAdiciona ('VTOP_B');  {'B - Faz download em mp4 de todos os vdeos marcados'}
    menuAdiciona ('VTOP_CTB');  {'CTRL+B - Faz download em vdeo de todos os vdeos marcados em vrios formatos'}
    menuAdiciona ('VTSELTIP');  {'J - Seleciona os tipos de downloads'}
    menuAdiciona ('VTSELTOC');  {'U - Seleciona os tipos de tocadores'}
    menuAdiciona ('VTOP_M');  {'M - Faz download do vdeo e depois converte de mp4 para mp3'}
    menuAdiciona ('VTOP_N');  {'N - Faz download em mp3 de todos os vdeos marcados'}
    menuAdiciona ('VTOP_CTN');  {'CTRL+N - Faz download em udio de todos os vdeos marcados em vrios formatos'}
    menuAdiciona ('VTOP_I');  {'I - Informaes sobre o vdeo'}
    menuAdiciona ('VTOP_CTI');  {'CTRL+I - Soletra informaes sobre o vdeo'}
    menuAdiciona ('VTOP_P');  {'P - Prxima pgina'}
    menuAdiciona ('VTOP_CTP');  {'CTRL+P - Vai para pgina'}
    menuAdiciona ('VTOP_A');  {'A - Pgina anterior'}
    menuAdiciona ('VTOP_CTA');  {'CTRL+A - Vai para pgina'}
    menuAdiciona ('VTOP_Q');  {'Q - Informa a posio na lista de vdeos, e o universo de vdeos'}
    menuAdiciona ('VTOP_CTQ');  {'CTRL+Q - Informa a pgina e o universo de pginas'}
    menuAdiciona ('VTOP_R');  {'R - Carrega a pgina do vdeo no Webvox'}
    menuAdiciona ('VTOP_T');  {'T e CTRL+T - Ativa e desativa a informao do tocador que ser utilizado'}
    menuAdiciona ('VTOP_W');  {'W - Informa o universo de vdeos'}
    menuAdiciona ('VTOP_CTW');  {'CTRL+W - Informa o universo de pginas'}
    menuAdiciona ('VTOP_S');  {'S - Faz download do vdeo em mp4'}
    menuAdiciona ('VTOP_CTS');  {'CTRL+S - Faz download em mp3 do audio do vdeo j convertido'}
    menuAdiciona ('VTOP_CTL');  {'CTRL+L - Copia o link do vdeo atual'}
    menuAdiciona ('VTOP_CTC');  {'CTRL+C ou CTRL+Z - Copia o ttulo e o link dos vdeos'}
    menuAdiciona ('VTOP_CTD');  {'CTRL+D - Copia as informaes sobre os vdeos'}
    menuAdiciona ('VTOP_L');  {'L - copia os links dos vdeos marcados, ou do atual'}
    menuAdiciona ('VTOP_C');  {'C - Informa o contedo do vdeo'}
    menuAdiciona ('VTOP_D');  {'d - Durao do vdeo'}
    menuAdiciona ('VTOP_DD');  {'D - Data e hora de publicao do vdeo'}
    menuAdiciona ('VTOP_PV');  {'Ponto e vrgula - Fala a verso'}
    MenuAdiciona ('VTOP_ESC');  {'ESC - Cancelar'}

    n := popupMenuSeleciona;
    if (n < 1) then
        result := ' '
    else
        result := opmenu[n];
end;

{--------------------------------------------------------}

procedure menuDownload (cod: string);
begin
    popupMenuAdiciona (cod, pegaTextoMensagem(cod));
end;

function selSetasDownload: char;
var n: integer;
const
    opmenu: string = 'B'+^B+'MN'+^N+'S'+^S;

begin

    mensagem ('VTDOWEN', 2); {'Selecione o tipo de download e tecle Enter para baixar'}

    popupMenuCria(wherex, wherey, 50, 8, RED);
    menuDownload ('VTOP_B');  {'B - Faz download em mp4 de todos os vdeos marcados'}
    menuDownload ('VTOP_CTB');  {'CTRL+B - Faz download em vdeo de todos os vdeos marcados em vrios formatos'}
    menuDownload ('VTOP_M');  {'M - Faz download do vdeo e depois converte de mp4 para mp3'}
    menuDownload ('VTOP_N');  {'N - Faz download em mp3 de todos os vdeos marcados'}
    menuDownload ('VTOP_CTN');  {'CTRL+N - Faz download em udio de todos os vdeos marcados em vrios formatos'}
    menuDownload ('VTOP_S');  {'S - Faz download do vdeo em mp4'}
    menuDownload ('VTOP_CTS');  {'CTRL+S - Faz download em mp3 do audio do vdeo j convertido'}
    MenuDownload ('VTOP_ESC');  {'ESC - Cancelar'}

    n := popupMenuSeleciona;
    if (n < 1) then
        result := ' '
    else
        result := opmenu[n];
end;

{--------------------------------------------------------}

procedure menuTocadores (cod: string);
begin
    popupMenuAdiciona (cod, pegaTextoMensagem(cod));
end;

function selSetasTocadores: char;
var n: integer;
const
    opmenu: string = ^M+''+'X'+^X+'V'+^V+'\'+'|'+^J;

begin

    mensagem ('VTTOCEN', 2); {'Selecione o tocador e tecle Enter para tocar'}

    popupMenuCria(wherex, wherey, 50, 10, RED);
    menuTocadores ('VTOP_ENT');  {'ENTER - Executa o vdeo com o tocador interno'}
    menuTocadores ('VTOP_CTR');  {' - Executa o vdeo com o primeiro tocador'}
    menuTocadores ('VTOP_X');  {'X - Executa o vdeo com o segundo tocador'}
    menuTocadores ('VTOP_CTX');  {'CTRL+X - Executa o vdeo com o terceiro tocador'}
    menuTocadores ('VTOP_V');  {'V - Executa o vdeo com o quarto tocador'}
    menuTocadores ('VTOP_CTV');  {'CTRL+V - Executa o vdeo com o quinto tocador'}
    menuTocadores ('VTOP_RAI');  {'Raiz - Executa o vdeo com o sexto tocador'}
    menuTocadores ('VTOP_BVT');  {'Barra Vertical - Executa o vdeo com o stimo tocador'}
    menuTocadores ('VTOP_CTEN');  {'CTRL+Enter - Exibe o vdeo com o navegador padro'}
    MenuTocadores ('VTOP_ESC');  {'ESC - Cancelar'}

    n := popupMenuSeleciona;
    if (n < 1) then
        result := ' '
    else
        result := opmenu[n];
end;

{--------------------------------------------------------}
{       folheia os vdeos informados pelo youtube
{--------------------------------------------------------}

procedure processaFuncao (c1, c2: char;
                         ultFolheado: integer;
                         var indice_atual: integer;
                         var mudouPagina: boolean);
var clipboardAcum: string;
    i, num, l, nPagina, m, n: integer;
    texto: string;
    estaSelec: boolean;
    infoFilme: TInfoFilme;
    filmeSelec: ISuperObject;
    dir: string;
nomeArq, endereco, textoAProcurar, diretorio, ref, nomeProg: string;
nomeArquivo: text;
    dirGrava: shortstring;
    salvaDir, dirAtual, confDirVideos  : string;
    c: char;
    formVideo, formAudio: string;
    confAudiobitrate: shortString;
    quality: string;
    player, numPagina, numero: string;
    sz: array [0..144] of char;

const
    CRLF = ^m^j;
label denovo, denovo1, informenomedoarquivo, fazdownload;

const
    NOPLAYER = false;
    NONAVEGADOR = true;

begin
    vpp := sintambiente('VOXTUBE','VIDEOSPORPAGINA');
denovo:
    clrscr;

    dir := sintambiente('VOXTUBE', 'DIRVOXTUBE');
    if dir = '' then
        dir := '\Winvox\som\voxtube';

            pagNoYouTube := (quantNoYouTube div strToInt(vpp));

    case (c1) of
        ESC:  begin
                  indice_atual := 0;
                  mensagem ('VTFOLTRM', 1); {'Folheamento dos vdeos terminado'}
              end;

        '.': leitorDeTela;

       '0': selFala('N');
        '1':  selFala('1');
        '2': selFala('2');
        '3': selFala('3');
        '4': selFala('4');
        '5': selFala('5');
        '6': selFala('6');
        '7': selFala('7');
        '8': selFala('8');
        '9': selFala('9');

        'A','a': begin
            if comEfeitos = true then
    sintsom ('VTPAGINA');
maxPag := 500 div strToInt(vpp);
            if pagNoYouTube+1 > maxPag then
            else
                    indice_atual := indice_atual + strToInt(vpp);
                num := (indice_atual+ultFolheado-2) div strToInt(vpp);
begin
            if num = 1 then
begin
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
            end;
    if (num > pagNoYouTube+1) or (num < 1) then
    begin
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
                indice_atual := 0;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp)-1);
if num = (1) then tokenProxPag := 'CBkQAQ';
if num = (2) then tokenProxPag := 'CBkQAA';
if num = (3) then tokenProxPag := 'CDIQAA';
if num = (4) then tokenProxPag := 'CEsQAA';
if num = (5) then tokenProxPag := 'CGQQAA';
if num = (6) then tokenProxPag := 'CH0QAA';
if num = (7) then tokenProxPag := 'CJYBEAA';
if num = (8) then tokenProxPag := 'CK8BEAA';
if num = (9) then tokenProxPag := 'CMgBEAA';
if num = (10) then tokenProxPag := 'COEBEAA';
if num = (11) then tokenProxPag := 'CPoBEAA';
if num = (12) then tokenProxPag := 'CJMCEAA';
if num = (13) then tokenProxPag := 'CKwCEAA';
if num = (14) then tokenProxPag := 'CMUCEAA';
if num = (15) then tokenProxPag := 'CN4CEAA';
if num = (16) then tokenProxPag := 'CPcCEAA';
if num = (17) then tokenProxPag := 'CJADEAA';
if num = (18) then tokenProxPag := 'CKkDEAA';
if num = (19) then tokenProxPag := 'CMIDEAA';
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                mudouPagina := true;
            if (num = maxPag) or (num = 1) then
            else
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
num := (indice_atual+ultFolheado-2) div strToInt(vpp);
sintWriteInt (num * strToInt(vpp)+1);
    end;
end;

        ^a: begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
//            nPagina := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
    numPagina := sintAmbiente ('VOXTUBE', 'NUMEROPAGINA');
    if numPagina = '' then
        begin
            numPagina := '';
        end;
    numero := numPagina;
            mensagem('VTNUMPAG', 1); {'Digite o nmero da pgina at '}
maxPag := 500 div strToInt(vpp);
            if pagNoYouTube+1 > maxPag then
            sintWriteInt (maxPag)
            else
            sintWriteInt (pagNoYouTube+1);
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
    sintetiza (numero);
        c := sintEditaCampo (numero, 1, wherey, 200, 80, true);
        numero := maiuscAnsi (numero);
        writeln;
            val (numero, num, l);
        if numero = '' then
        numero := numPagina;
            strPCopy (sz, numero);
            writePrivateProfileString('VOXTUBE', 'NUMEROPAGINA',     sz, 'DOSVOX.INI');
        if c = ESC then
            begin
            numero := '';
                    mensagem ('VTDESIST', 1);    {'Desistiu'}
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
        exit;
            end;
begin
    if num > maxPag then
    begin
            mensagem('VTPAGNE', 1); {'Pgina no existe'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
            if num = maxPag then
begin
            mensagem('VTULTPAG', 1); {'ltima pgina'}
            end;
    if (num > pagNoYouTube+1) or (num < 1) then
    begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
                indice_atual := 0;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp)-1);
if num = (1) then tokenProxPag := 'CBkQAQ';
if num = (2) then tokenProxPag := 'CBkQAA';
if num = (3) then tokenProxPag := 'CDIQAA';
if num = (4) then tokenProxPag := 'CEsQAA';
if num = (5) then tokenProxPag := 'CGQQAA';
if num = (6) then tokenProxPag := 'CH0QAA';
if num = (7) then tokenProxPag := 'CJYBEAA';
if num = (8) then tokenProxPag := 'CK8BEAA';
if num = (9) then tokenProxPag := 'CMgBEAA';
if num = (10) then tokenProxPag := 'COEBEAA';
if num = (11) then tokenProxPag := 'CPoBEAA';
if num = (12) then tokenProxPag := 'CJMCEAA';
if num = (13) then tokenProxPag := 'CKwCEAA';
if num = (14) then tokenProxPag := 'CMUCEAA';
if num = (15) then tokenProxPag := 'CN4CEAA';
if num = (16) then tokenProxPag := 'CPcCEAA';
if num = (17) then tokenProxPag := 'CJADEAA';
if num = (18) then tokenProxPag := 'CKkDEAA';
if num = (19) then tokenProxPag := 'CMIDEAA';
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                mudouPagina := true;
            if (num = maxPag) or (num = 1) then
            else
            begin
            if comEfeitos = true then
            begin
    sintsom ('VTPAGINA');
    end
    else
            mensagem('VTPAG', 1); {'Pgina '}
            end;
        if num = 1 then
        begin
            if comEfeitos = true then
    sintsom ('VTPAGINA');
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
num := (indice_atual+ultFolheado-2) div strToInt(vpp);
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt (num * strToInt(vpp)+1);
        exit;
        end
        else
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt ((num-1) * strToInt(vpp)+1);
//num := (indice_atual+ultFolheado-2) div strToInt(vpp);
    end;
end;

        'B','b':              begin //Baixa o vdeo em mp4
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            if m = 0 then
            mensagem('VTDBMOA', 1); {'Deseja baixar em mp4 o vdeo?'}
            if m = 1 then
            mensagem('VTDBMOAM', 1); {'Deseja baixar em mp4 o vdeo marcado?'}
            if m > 1 then
            mensagem('VTDBMASM', 1); {'Deseja baixar em mp4 os vdeos marcados?'}
    c := sintreadkey;
    if (upcase(c) = 'S') or (upcase(c) = ENTER) then
            begin
            if m = 0 then
            begin
            mensagem('VTOBAIVI', 1); {'Ok, baixando o vdeo'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
            end;
            if m = 1 then
            begin
            mensagem('VTOBAIVM', 1); {'Ok, baixando o vdeo marcado'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
            end;
            if m > 1 then
            mensagem('VTBAIMAR', 1); {'Ok, baixando os vdeos marcados. Para cancelar tecle CTRL+c'}
            if gravaAsBuscas = false then
    gravaAsBuscas := not gravaAsBuscas;
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
                                endereco := endereco +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := subsCaracInvalidos (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if gravaAsBuscas = true then
    gravaAsBuscas := not gravaAsBuscas;
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if confDirVideos   = '' then confDirVideos   := '.';
        getDir (0, salvaDir);
        {$I-} chdir (confDirVideos  );  {$I+}
        if ioresult <> 0 then exit;
        getDir (0, dirAtual);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\youtube-dl');
            if executaProg(nomeProg, '', '--console-title --recode-video mp4 -a' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('dindondin');
                    mensagem ('VTOK', 1);  {'Ok!'}
                    while keypressed do readkey;
                end;
        chdir (salvaDir);
             end
             else
            mensagem ('VTDESIST', 1);  {'Desistiu'}
             end;

        ^b:              begin //Baixa vdeos em vrios formatos
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            mensagem ('VTBVIDEO', 1); {'Baixando em vdeo'}
            mensagem ('VTESCSET', 1); {'Escolha com as setas o formato'}
                    c := selSetasNumerosVid;
                begin
  If c in ['1'..'6'] Then
else
    begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
//c :=#0;
            exit;
    end;
                end;
            if gravaAsBuscas = false then
    gravaAsBuscas := not gravaAsBuscas;
            if m = 0 then
            mensagem('VTBVIFOR', 1); {'Baixando o vdeo no formato'}
            if m = 1 then
            mensagem('VTBVMFOR', 1); {'Baixando o vdeo marcado no formato'}
            if m > 1 then
            mensagem('VTBVSMFO', 1); {'Baixando os vdeos marcados no formato'}
if c = '1' then
mensagem('VTMP4', 1) {'mp4'}
else
if c = '2' then
mensagem('VTOGG', 1) {'ogg'}
else
if c = '3' then
mensagem('VTFLV', 1) {'flv'}
else
if c = '4' then
mensagem('VTWEBM', 1) {'webm'}
else
if c = '5' then
mensagem('VTMKV', 1) {'mkv'}
else
if c = '6' then
mensagem('VTAVI', 1); {'avi'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
                endereco := '';
                clipboardAcum := '';
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
                                endereco := endereco +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := subsCaracInvalidos (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if gravaAsBuscas = true then
    gravaAsBuscas := not gravaAsBuscas;
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if confDirVideos   = '' then confDirVideos   := '.';
        getDir (0, salvaDir);
        {$I-} chdir (confDirVideos  );  {$I+}
        if ioresult <> 0 then exit;
        getDir (0, dirAtual);
if c = '1' then
formVideo := 'mp4'
else
if c = '2' then
formVideo := 'ogg'
else
if c = '3' then
formVideo := 'flv'
else
if c = '4' then
formVideo := 'webm'
else
if c = '5' then
formVideo := 'mkv'
else
if c = '6' then
formVideo := 'avi';
if (formVideo <> 'mp4') and
(formVideo <> 'ogg') and
(formVideo <> 'flv') and
(formVideo <> 'webm') and
(formVideo <> 'mkv') and
(formVideo <> 'avi') then
formVideo := 'mkv';
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\youtube-dl');
            if executaProg(nomeProg, '', '--console-title --recode-video ' + formVideo + ' -a ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('dindondin');
                    mensagem ('VTOK', 1);  {'Ok!'}
                    while keypressed do readkey;
                end;
        chdir (salvaDir);
             end;

        'C', 'c': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 textColor (yellow);
            mensagem('VTCONTEUD', 1); {'Contedo: '}
                 sintWriteln (infoFilme.conteudo);
                 textColor (white);
                 writeln;
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
             end;

        ^c:  // CTRL+c   -->  titulo<crlf>paginaweb<crlf>
             begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                m := 0;
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
    m := m+1;
                                endereco := endereco +
                                    Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF + CRLF;
                                clipboardAcum := clipboardAcum +
                                    Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                        endereco :=
                            Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if m > 1 then
            mensagem('VTBLKCRGS', 1) {'Carregados'}
            else
            mensagem('VTBLKCRG', 1); {'Carregado'}
            if gravaAsBuscas = true then
            if m > 1 then
            mensagem('VTGRAVADS', 1) {'Gravados'}
            else
            mensagem('VTGRAVAD', 1); {'Gravado'}
    denovo1:
    if not gravaAsBuscas then
exit
else
    mensagem ('VTDESEDI', 0);    {'Deseja editar o arquivo? '}
    c := sintReadKey;
    writeln (c);
    if (upcase(c) = 'N') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
    exit;
    if upcase(c) <> 'S' then
    goto denovo1;
    if upcase(c) = 'S' then
        begin
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\edivox.exe ');
            if executaProg(nomeProg, '', '/L ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    delay (5);
                end
            else
                begin
                    mensagem ('VTERREDI', 1);    {'Erro ao acionar o editor de textos'}
                    exit;
                end;
        end;
        end;

        'd': begin //Informa durao
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 textColor (white);
                 mensagem ('VTDURA', 0);   {'Durao: '}
                 textColor (yellow);
    infoFilme := obtemInfoFilme (ultFolheado);
                 if (infoFilme.duracao div 60) = 0 then
                 begin
                     sintWriteln (intToStr (infoFilme.duracao mod 60));
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
            mensagem('VTSEGUNS', 1); {' segundos'}
                 end
                 else
                 begin
                     sintWriteln (intToStr (infoFilme.duracao div 60));
                     if (intToStr (infoFilme.duracao div 60)) = '1' then
            mensagem('VTMINUTO', 1) {'Minuto'}
            else
            mensagem('VTMINUTS', 1); {'Minutos'}
                                 sintWriteln  (intToStr (infoFilme.duracao mod 60));
            begin
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
            mensagem('VTSEGUNS', 1); {' segundos'}
            end;
                 end;
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
             end;

'D': begin //Informa data e hora de publicao do vdeo
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 textColor (white);
                 mensagem ('VTDH', 0);   {'Data e hora de publicao: '}
                 textColor (yellow);
sintwriteln(infofilme.datadepublicacao+' - '+infofilme.horadepublicacao);
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
end;

        ^d:  // CTRL+d Carrega os dados dos vdeos
             begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                m := 0;
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
    sintWriteLn (intToStr (i));
    m := m+1;
                            begin
                                infoFilme := obtemInfoFilme(i);
                                endereco := clipboardAcum + 'Ttulo: ' + infoFilme.titulo + CRLF +
                                                                 'Autor: ' +infoFilme.autor + CRLF;
                                clipBoardAcum := clipboardAcum + 'Ttulo: ' + infoFilme.titulo + CRLF +
                                                                 'Autor: ' +infoFilme.autor + CRLF;
                            end;
                                                             if (infoFilme.duracao) < 60 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
                    end;
                                                             if infoFilme.duracao <= 60 then
else
begin
                     if ((infoFilme.duracao mod 60) <> 1) and
                                                             ((infoFilme.duracao) < 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
end
else
                     if ((infoFilme.duracao mod 60) = 1) and
                                                             ((infoFilme.duracao) < 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUND'))  {' segundo'} + CRLF;
end;
end;
                     if ((infoFilme.duracao mod 60) <> 1) and
                                                             ((infoFilme.duracao) >= 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTS')    {' minutos '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
end
else
                     if ((infoFilme.duracao mod 60) = 1) and
                                                             ((infoFilme.duracao) >= 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTS')    {' minutos '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUND'))  {' segundo'} + CRLF;
end;
                                                             if infoFilme.duracao = 60 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto'} + CRLF;
                    end;
                                                             if infoFilme.duracao = 1 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + intToStr (infoFilme.duracao mod 60)
                                                                             + pegaTextoMensagem ('VTSEGUND')    {' segundo '} + CRLF;
                    end;
                                endereco := clipboardAcum +
                                                                 'Data e hora de publicao: ' + infoFilme.datadepublicacao + ' - ' + infoFilme.horadepublicacao + CRLF +
                                                                 'Visualizaes: ' + intToStr (infoFilme.visualizacoes) + CRLF +
                                                                 'Contedo: ' + infoFilme.conteudo + CRLF +
                                                                 'Pgina WEB: ' + infoFilme.paginaweb + CRLF + CRLF;
                                clipBoardAcum := clipboardAcum +
                                                                 'Data e hora de publicao: ' + infoFilme.datadepublicacao + ' - ' + infoFilme.horadepublicacao + CRLF +
                                                                 'Visualizaes: ' + intToStr (infoFilme.visualizacoes) + CRLF +
                                                                 'Contedo: ' + infoFilme.conteudo + CRLF +
                                                                 'Pgina WEB: ' + infoFilme.paginaweb + CRLF + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                    begin
    sintWriteLn (intToStr (ultFolheado));
                        infoFilme := obtemInfoFilme(ultFolheado);
                        endereco := 'Ttulo: ' + infoFilme.titulo + crlf +
                                                                 'Autor: ' +infoFilme.autor + CRLF;
                        clipboardAcum := 'Ttulo: ' + infoFilme.titulo + crlf +
                                                                 'Autor: ' +infoFilme.autor + CRLF;
                    end;
                                                             if infoFilme.duracao < 60 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
                    end;
                                                             if infoFilme.duracao = 60 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto'} + CRLF;
                    end;
                                                             if infoFilme.duracao = 1 then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + intToStr (infoFilme.duracao mod 60)
                                                                             + pegaTextoMensagem ('VTSEGUND')    {' segundo '} + CRLF;
                    end;
                                                             if infoFilme.duracao <= 60 then
else
begin
                     if ((infoFilme.duracao mod 60) <> 1) and
                                                             ((infoFilme.duracao) < 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
                    end
else
                     if ((infoFilme.duracao mod 60) = 1) and
                                                             ((infoFilme.duracao) < 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUND'))  {' segundo'} + CRLF;
end;
end;
                     if ((infoFilme.duracao mod 60) <> 1) and
                                                             ((infoFilme.duracao) >= 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTS')    {' minutos '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUNS'))  {' segundos'} + CRLF;
end
else
                     if ((infoFilme.duracao mod 60) = 1) and
                                                             ((infoFilme.duracao) >= 120) then
begin
                                clipBoardAcum := clipboardAcum +
                                                                 'Durao: ' + (intToStr (infoFilme.duracao div 60)
                                                                             + pegaTextoMensagem ('VTMINUTO')    {' minuto '}
                                                                             + intToStr (infoFilme.duracao mod 60)
                                 + pegaTextoMensagem ('VTSEGUND'))  {' segundo'} + CRLF;
end;
                                endereco := clipboardAcum +
                                                                 'Data e hora de publicao: ' + infoFilme.datadepublicacao + ' - ' + infoFilme.horadepublicacao + CRLF +
                                                                 'Visualizaes: ' + intToStr (infoFilme.visualizacoes) + CRLF +
                                                                 'Contedo: ' + infoFilme.conteudo + CRLF +
                                                                 'Pgina WEB: ' + infoFilme.paginaweb + CRLF + CRLF;
                                clipBoardAcum := clipboardAcum +
                                                                 'Data e hora de publicao: ' + infoFilme.datadepublicacao + ' - ' + infoFilme.horadepublicacao + CRLF +
                                                                 'Visualizaes: ' + intToStr (infoFilme.visualizacoes) + CRLF +
                                                                 'Contedo: ' + infoFilme.conteudo + CRLF +
                                                                 'Pgina WEB: ' + infoFilme.paginaweb + CRLF + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if m > 1 then
            mensagem('VTBLKCRGS', 1) {'Carregados'}
            else
            mensagem('VTBLKCRG', 1); {'Carregado'}
            if gravaAsBuscas = false then
            exit;
            if gravaAsBuscas = true then
            if m > 1 then
            mensagem('VTGRAVADS', 1) {'Gravados'}
            else
            mensagem('VTGRAVAD', 1); {'Gravado'}
    if not gravaAsBuscas then
exit
else
    mensagem ('VTDESEDI', 0);    {'Deseja editar o arquivo? '}
    c := sintReadKey;
    writeln (c);
    if (upcase(c) = 'N') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
    exit;
    if upcase(c) <> 'S' then
    goto denovo1;
    if upcase(c) = 'S' then
        begin
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\edivox.exe ');
            if executaProg(nomeProg, '', '/L ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    delay (5);
                end
            else
                begin
                    mensagem ('VTERREDI', 1);    {'Erro ao acionar o editor de textos'}
                    exit;
                end;
        end;
        end;

                'E','e': begin //Apaga as memrias
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                limpaMemoria;
end;

        ENTER: begin //Tocador zero
            if comEfeitos = true then
    sintsom ('dtfm_4')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD0', 1); {'Com o tocador 0'}
    player := sintambiente('VOXTUBE','TOCADOR0');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR0');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 0);
            end;

        #10:   begin // CTRL+Enter ou CTRL+m (^M) ou CTRL+j (^J) - Exibe com o navegador
            if comEfeitos = true then
    sintsom ('dtfm_0')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
            begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD00', 1); {'Com o tocador do navegador'}
            end;
        tocavideo (infoFilme.paginaWeb, NONAVEGADOR, 0);
        end;

        'F','f': begin //Informa o nmero do vdeo na pgina
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
        end;

      ^G, 'G','g': //Ativa gravao dos vdeos em um txt com o nome da busca
begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    gravaAsBuscas := not gravaAsBuscas;
    if gravaAsBuscas then
        mensagem ('VTGRAVAN', 1) {'Gravando as buscas'}
    else
        mensagem ('VTSEMGRA', 1) {'Sem gravar as buscas'}
end;

      ^H, 'H','h': //Configura com ou sem efeitos
begin
            if comEfeitos = true then
            sintclek
            else
    sintsom ('blimblimblom');
    comEfeitos := not comEfeitos;
    if comEfeitos then
        mensagem ('VTCOMEFE', 1) {'Com Efeitos'}
    else
        mensagem ('VTSEMEFE', 1) {'Sem efeitos'}
end;

        'I','i': begin //Informaes sobre o(s) vdeo(s)
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 mensagem ('VTAUTOR', 0);  {'Autor: '}
                 textColor (yellow);
                 sintWriteln (infoFilme.autor);
                 textColor (white);
                 mensagem ('VTDURA', 0);   {'Durao: '}
                 textColor (yellow);
    infoFilme := obtemInfoFilme (ultFolheado);
                 if (infoFilme.duracao div 60) = 0 then
                 begin
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                     sintWriteln (intToStr (infoFilme.duracao mod 60));
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
                 end
                 else
                 begin
                     sintWriteln (intToStr (infoFilme.duracao div 60));
                     if (intToStr (infoFilme.duracao div 60)) = '1' then
            mensagem('VTMINUTO', 1) {'Minuto'}
            else
            mensagem('VTMINUTS', 1); {'Minutos'}
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                                 sintWriteln  (intToStr (infoFilme.duracao mod 60));
            begin
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
            end;
                 end;
                 textColor (white);
                 mensagem ('VTDH', 0);  {'Data e hora de publicao: '}
                 textColor (yellow);
sintwriteln(infofilme.datadepublicacao+' - '+infofilme.horadepublicacao);
                 textColor (white);
                 mensagem ('VTVISUAL', 0);  {'Visualizaes: '}
                 textColor (yellow);
                 sintWriteln (intToStr(infoFilme.visualizacoes));
                 textColor (yellow);
            mensagem('VTCONTEUD', 1); {'Contedo: '}
                 sintWriteln (infoFilme.conteudo);
                 textColor (white);
                 writeln;
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
             end;

        ^i: begin //Informaes soletradas sobre o(s) vdeo(s)
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 mensagem ('VTAUTOR', 0);  {'Autor: '}
                 textColor (yellow);
                 sintsoletra (infoFilme.autor);
                 textColor (white);
                 mensagem ('VTDURA', 0);   {'Durao: '}
                 textColor (yellow);
    infoFilme := obtemInfoFilme (ultFolheado);
                 if (infoFilme.duracao div 60) = 0 then
                 begin
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                     sintsoletra (intToStr (infoFilme.duracao mod 60));
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
                 end
                 else
                 begin
                     sintsoletra (intToStr (infoFilme.duracao div 60));
                     if (intToStr (infoFilme.duracao div 60)) = '1' then
            mensagem('VTMINUTO', 1) {'Minuto'}
            else
            mensagem('VTMINUTS', 1); {'Minutos'}
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                                 sintsoletra  (intToStr (infoFilme.duracao mod 60));
            begin
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
            end;
                 end;
                 textColor (white);
                 mensagem ('VTDH', 0);  {'Data e hora de publicao: '}
                 textColor (yellow);
sintwriteln(infofilme.datadepublicacao+' - '+infofilme.horadepublicacao);
                 textColor (white);
                 mensagem ('VTVISUAL', 0);  {'Visualizaes: '}
                 textColor (yellow);
                 sintsoletra (intToStr(infoFilme.visualizacoes));
                 textColor (yellow);
            mensagem('VTCONTEUD', 1); {'Contedo: '}
                 sintsoletra (infoFilme.conteudo);
                 textColor (white);
                 writeln;
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
             end;

        'J','j': begin //Opes de download
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
                        if ultFolheado > 0 then
                            begin
                                writeln (infoFilme.titulo);
                                writeln;
                            end;
                         c1 := selSetasDownload;
                         goto denovo;
                     end;

      'K','k': //Informa as visualizaes
begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    informaAsVisualizacoes := not informaAsVisualizacoes;
    if informaAsVisualizacoes then
        mensagem ('VTINFVIS', 1) {'Informando as visualizaes'}
    else
        mensagem ('VTSEMVIS', 1) {'Sem informar as vizualizaes'}
end;

      ^k: begin //Informa o nmero de visualizaes
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn (intToStr (ultFolheado));
    infoFilme := obtemInfoFilme (ultFolheado);
                 writeln (infoFilme.titulo);
                 textColor (white);
                 sintWriteln (intToStr(infoFilme.visualizacoes));
                 textColor (yellow);
                 mensagem ('VTVISUAL', 0);  {'Visualizaes: '}
                 textColor (yellow);
            mensagem('VTTITULO', 1); {'Ttulo: '}
                 textColor (white);
                 writeln;
             end;

        'L','l':              begin //Carrega endereo do(s) vdeo(s) na rea de transferncia
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                m := 0;
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
    m := m+1;
                                endereco := endereco +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if m > 1 then
            mensagem('VTBLKCRGS', 1) {'Carregados'}
            else
            mensagem('VTBLKCRG', 1); {'Carregado'}
            if gravaAsBuscas = true then
            if m > 1 then
            mensagem('VTGRAVADS', 1) {'Gravados'}
            else
            mensagem('VTGRAVAD', 1); {'Gravado'}
    if not gravaAsBuscas then
exit
else
    mensagem ('VTDESEDI', 0);    {'Deseja editar o arquivo? '}
    c := sintReadKey;
    writeln (c);
    if (upcase(c) = 'N') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
    exit;
    if upcase(c) <> 'S' then
    goto denovo1;
    if upcase(c) = 'S' then
        begin
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\edivox.exe ');
            if executaProg(nomeProg, '', '/L ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    delay (5);
                end
            else
                begin
                    mensagem ('VTERREDI', 1);    {'Erro ao acionar o editor de textos'}
                    exit;
                end;
        end;
        end;

        ^l:  // CTRL+l   -->  titulo<crlf>paginaweb<crlf>
             begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (ultFolheado));
                                filmeSelec := listaDeFilmes.O[ultFolheado-1];
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            mensagem('VTBLKCRG', 1); {'Carregado'}
            if gravaAsBuscas = true then
            mensagem('VTGRAVAD', 1); {'Gravado'}
    if not gravaAsBuscas then
exit
else
    mensagem ('VTDESEDI', 0);    {'Deseja editar o arquivo? '}
    c := sintReadKey;
    writeln (c);
    if (upcase(c) = 'N') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
    exit;
    if upcase(c) <> 'S' then
    goto denovo1;
    if upcase(c) = 'S' then
        begin
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\edivox.exe ');
            if executaProg(nomeProg, '', '/L ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    delay (5);
                end
            else
                begin
                    mensagem ('VTERREDI', 1);    {'Erro ao acionar o editor de textos'}
                    exit;
                end;
        end;
        end;

        'M','m': begin //Baixa o vdeo apagando ou no o MP4 original
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            mensagem('VTBAVIDE', 1); {'Baixando o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
    mensagem ('VTMP4MP3', 1); {' em mp4, para obter o udio em mp3, aguarde.'}
                Extraiaudio(infofilme);
end;

        'N','n':              begin //Baixa os vdeos marcados em MP3
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            if m = 0 then
            mensagem('VTDBMOV', 1); {'Deseja baixar em mp3 o udio?'}
            if m = 1 then
            mensagem('VTDBMOVM', 1); {'Deseja baixar em mp3 o udio marcado?'}
            if m > 1 then
            mensagem('VTDBMVSM', 1); {'Deseja baixar em mp3 os udios marcados?'}
    c := sintreadkey;
    if (upcase(c) = 'S') or (upcase(c) = ENTER) then
            begin
            if m = 0 then
            begin
            mensagem('VTOBAUDI', 1); {'Ok, baixando o udio'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
            end;
            if m = 1 then
            begin
            mensagem('VTOBAUDM', 1); {'Ok, baixando o udio marcado'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
            end;
            if m > 1 then
            mensagem('VTBAUDMA', 1); {'Ok, baixando os udios marcados. Para cancelar tecle CTRL+c'}
            if gravaAsBuscas = false then
    gravaAsBuscas := not gravaAsBuscas;
            if m > 1 then
                mensagem ('VTAUDIOS', 1)   {'udios'}
            else
                mensagem ('VTAUDIO', 1);   {'udio'}
//                mensagem ('VTVIDEO', 1);   {' Vdeo '}
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
                                endereco := endereco +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := subsCaracInvalidos (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if gravaAsBuscas = true then
    gravaAsBuscas := not gravaAsBuscas;
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if confDirVideos   = '' then confDirVideos   := '.';
        getDir (0, salvaDir);
        {$I-} chdir (confDirVideos  );  {$I+}
        if ioresult <> 0 then exit;
        getDir (0, dirAtual);
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\youtube-dl');
            if executaProg(nomeProg, '', '--console-title -x --audio-format mp3 -a' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                    mensagem ('VTOK', 1);  {'Ok!'}
                    while keypressed do readkey;
                end;
        chdir (salvaDir);
             end
             else
            mensagem ('VTDESIST', 1);  {'Desistiu'}
             end;

        ^n:              begin //Baixa os vdeos marcados em vrios formatos
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            mensagem ('VTBAUDIO', 1); {'Baixando em udio'}
            mensagem ('VTESCSET', 1); {'Escolha com as setas o formato'}
                    c := selSetasNumerosAud;
                begin
  If c in ['1'..'7'] Then
else
    begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
//c :=#0;
            exit;
    end;
                end;
            if gravaAsBuscas = false then
    gravaAsBuscas := not gravaAsBuscas;
            if m = 0 then
            mensagem('VTBANFOR', 1); {'Baixando o udio no formato'}
            if m = 1 then
            mensagem('VTBAMNFO', 1); {'Baixando o udio marcado no formato'}
            if m > 1 then
            mensagem('VTBASMNF', 1); {'Baixando os udios marcados no formato'}
if c = '1' then
mensagem('VTM4A', 1) {'m4a'}
else
if c = '2' then
mensagem('VTAAC', 1) {'aac'}
else
if c = '3' then
mensagem('VTOGG', 1) {'ogg'}
else
if c = '4' then
mensagem('VTMP3', 1) {'mp3'}
else
if c = '5' then
mensagem('VTOPUS', 1) {'opus'}
else
if c = '6' then
mensagem('VTWAV', 1) {'wav'}
else
if c = '7' then
mensagem('VTFLAC', 1); {'flac'}
            mensagem('VTCANCTC', 1); {'Para cancelar tecle CTRL+C'}
                endereco := '';
                clipboardAcum := '';
            mensagem('VTAUDIO', 1); {'udio '}
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
                                endereco := endereco +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    begin
                        filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'http://www.youtube.com/watch?v='+
                                    filmeSelec['id']['videoId'].AsString + CRLF;
                        clipboardAcum :=
                            'http://www.youtube.com/watch?v='+
                            filmeSelec['id']['videoId'].AsString + CRLF;
                    end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := subsCaracInvalidos (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if gravaAsBuscas = true then
    gravaAsBuscas := not gravaAsBuscas;
    confDirVideos  := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if confDirVideos   = '' then confDirVideos   := '.';
        getDir (0, salvaDir);
        {$I-} chdir (confDirVideos  );  {$I+}
        if ioresult <> 0 then exit;
        getDir (0, dirAtual);
    confAudiobitrate  := (sintAmbiente('VOXTUBE', 'AUDIOBITRATE'));
        confAudiobitrate := intToStr(5);
        if confAudiobitrate = intToStr(48000) then
        confAudiobitrate := intToStr(9);
        if confAudiobitrate = intToStr(64000) then
        confAudiobitrate := intToStr(8);
        if confAudiobitrate = intToStr(80000) then
        confAudiobitrate := intToStr(7);
        if confAudiobitrate = intToStr(96000) then
        confAudiobitrate := intToStr(6);
        if (confAudiobitrate = intToStr(128000)) or (confAudiobitrate = ('')) then
        confAudiobitrate := intToStr(5);
        if confAudiobitrate = intToStr(160000) then
        confAudiobitrate := intToStr(4);
        if confAudiobitrate = intToStr(192000) then
        confAudiobitrate := intToStr(3);
        if confAudiobitrate = intToStr(224000) then
        confAudiobitrate := intToStr(2);
        if confAudiobitrate = intToStr(256000) then
        confAudiobitrate := intToStr(1);
        if confAudiobitrate = intToStr(320000) then
        confAudiobitrate := intToStr(0);
quality := ('--audio-quality ' + confAudiobitrate);
if c = '1' then
formAudio := 'm4a'
else
if c = '2' then
formAudio := 'aac'
else
if c = '3' then
formAudio := 'vorbis'
else
if c = '4' then
formAudio := 'mp3'
else
if c = '5' then
formAudio := 'opus'
else
if c = '6' then
formAudio := 'wav'
else
if c = '7' then
formAudio := 'flac';
if (formAudio <> 'm4a') and
(formAudio <> 'aac') and
(formAudio <> 'vorbis') and
(formAudio <> 'mp3') and
(formAudio <> 'opus') and
(formAudio <> 'wav') and
(formAudio <> 'flac') then
formAudio := 'mp3';
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\youtube-dl');
            if executaProg(nomeProg, '', '--console-title -x --audio-format ' + formAudio + ' ' + quality + ' -a ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('msn_switching');
                    mensagem ('VTOK', 1);  {'Ok!'}
                    while keypressed do readkey;
                end;
        chdir (salvaDir);
             end;

      ^o, 'O','o': //Configura se apaga ou no o MP4 original
begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if confApaga = '' then
    begin
        mensagem ('VTATIVE', 1); {'Ative esta opo, configurando apagar ou no, o original mp4, no Painel de Configurao'}
    exit;
    end
        else
    apagaArqMp4 := not apagaArqMp4;
    if apagaArqMp4 then
        mensagem ('VTAPAGAN', 1) {'Apagando o mp4 original'}
    else
        mensagem ('VTSEMAPA', 1) {'Sem apagar o mp4 original'}
end;

        'P','p': begin //Vai para a prxima pgina
            if comEfeitos = true then
    sintsom ('VTPAGINA');
maxPag := 500 div strToInt(vpp);
                if tokenProxPag <>'' then
                begin
                    indice_atual := indice_atual + strToInt(vpp);
num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                    mudouPagina := true;
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
    sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt ((num-1) * strToInt(vpp)+1);
                end
                else
            begin
            mensagem('VTULTPAG', 1); {'ltima pgina'}
    sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
//num := (indice_atual+ultFolheado-2) div strToInt(vpp);
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn(intToStr (indice_atual+ultFolheado-1));
            end;
             end;

        ^p: begin //Vai para pgina
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
//            nPagina := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
    numPagina := sintAmbiente ('VOXTUBE', 'NUMEROPAGINA');
    if numPagina = '' then
        begin
            numPagina := '';
        end;
    numero := numPagina;
            mensagem('VTNUMPAG', 1); {'Digite o nmero da pgina at '}
maxPag := 500 div strToInt(vpp);
            if pagNoYouTube+1 > maxPag then
            sintWriteInt (maxPag)
            else
            sintWriteInt (pagNoYouTube+1);
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
    sintetiza (numero);
        c := sintEditaCampo (numero, 1, wherey, 200, 80, true);
        numero := maiuscAnsi (numero);
        writeln;
            val (numero, num, l);
        if numero = '' then
        numero := numPagina;
            strPCopy (sz, numero);
            writePrivateProfileString('VOXTUBE', 'NUMEROPAGINA',     sz, 'DOSVOX.INI');
        if c = ESC then
            begin
            numero := '';
                    mensagem ('VTDESIST', 1);    {'Desistiu'}
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
        exit;
            end;
begin
    if num > maxPag then
    begin
            mensagem('VTPAGNE', 1); {'Pgina no existe'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
            if num = maxPag then
begin
            mensagem('VTULTPAG', 1); {'ltima pgina'}
            end;
    if (num > pagNoYouTube+1) or (num < 1) then
    begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
                indice_atual := 0;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp)-1);
if num = (1) then tokenProxPag := 'CBkQAQ';
if num = (2) then tokenProxPag := 'CBkQAA';
if num = (3) then tokenProxPag := 'CDIQAA';
if num = (4) then tokenProxPag := 'CEsQAA';
if num = (5) then tokenProxPag := 'CGQQAA';
if num = (6) then tokenProxPag := 'CH0QAA';
if num = (7) then tokenProxPag := 'CJYBEAA';
if num = (8) then tokenProxPag := 'CK8BEAA';
if num = (9) then tokenProxPag := 'CMgBEAA';
if num = (10) then tokenProxPag := 'COEBEAA';
if num = (11) then tokenProxPag := 'CPoBEAA';
if num = (12) then tokenProxPag := 'CJMCEAA';
if num = (13) then tokenProxPag := 'CKwCEAA';
if num = (14) then tokenProxPag := 'CMUCEAA';
if num = (15) then tokenProxPag := 'CN4CEAA';
if num = (16) then tokenProxPag := 'CPcCEAA';
if num = (17) then tokenProxPag := 'CJADEAA';
if num = (18) then tokenProxPag := 'CKkDEAA';
if num = (19) then tokenProxPag := 'CMIDEAA';
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                mudouPagina := true;
            if (num = maxPag) or (num = 1) then
            else
            begin
            if comEfeitos = true then
            begin
    sintsom ('VTPAGINA');
    end
    else
            mensagem('VTPAG', 1); {'Pgina '}
            end;
        if num = 1 then
        begin
            if comEfeitos = true then
    sintsom ('VTPAGINA');
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
num := (indice_atual+ultFolheado-2) div strToInt(vpp);
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt (num * strToInt(vpp)+1);
        exit;
        end
        else
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt ((num-1) * strToInt(vpp)+1);
//num := (indice_atual+ultFolheado-2) div strToInt(vpp);
    end;
end;

        'Q','q': begin //Informa o nmero do vdeo e o universo de vdeos
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (indice_atual+ultFolheado-1));
            mensagem('VTUNIVER', 0);   {' de um universo de '}
            sintWriteInt (quantNoYouTube);
    end;

        ^q: begin //Informa a pgina e o universo de pginas
              if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
            mensagem('VTPAG', 1); {'Pgina '}
    sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
            mensagem('VTUNIVER', 0);   {' de um universo de '}
            if pagNoYouTube < 1 then
            begin
            mensagem('VTUMA', 1); {' Uma'}
            exit;
            end;
            if pagNoYouTube = 1 then
            begin
            mensagem('VTDUAS', 1); {' Duas'}
            end
            else
            begin
            sintWriteInt (pagNoYouTube+1);
    end;
    end;

        'R','r': begin //Carrega a pgina do vdeo no Webvox
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (ultFolheado));
                mensagem ('VTCARVID', 1);   {'Carregando a pgina deste vdeo no Webvox'}
                                filmeSelec := listaDeFilmes.O[ultFolheado-1];
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\webvox.exe');
            if executaProg (nomeProg, '', ' http://www.youtube.com/watch?v='+ filmeSelec['id']['videoId'].AsString) then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    while keypressed do readkey;
                end;
             end;

        'S','s': begin //Baixando em mp4 o vdeo
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            mensagem('VTBAIVID', 1); {'Baixando em mp4 o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
                salvaFilme (infoFilme);
             end;

^s: begin //Baixa o vdeo em mp4, para obter o udio em mp3
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            mensagem('VTBAVIDE', 1); {'Baixando o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
    mensagem ('VTMP4MP3', 1); {' em mp4, para obter o udio em mp3, aguarde.'}
    ExtraiaudioMp3(infofilme);
end;

      ^t, 'T','t': //Informa ou no informa os tocadores
begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    informaOsTocadores := not informaOsTocadores;
    if informaOsTocadores then
        mensagem ('VTINFORM', 1) {'Informando os tocadores'}
    else
        mensagem ('VTSEMINF', 1) {'Sem informar os tocadores'}
end;

        'U','u': begin //Menu dos tocadores
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
                        if ultFolheado > 0 then
                            begin
                                writeln (infoFilme.titulo);
                                writeln;
                            end;
                         c1 := selSetasTocadores;
                         goto denovo;
                     end;

        'V', 'v': begin //Quarto tocador
            if comEfeitos = true then
    sintsom ('dtfm_4')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD4', 1); {'Com o tocador 4'}
    player := sintambiente('VOXTUBE','TOCADOR4');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR4');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 4);
            end;

        ^v: begin   //Quinto tocador
            if comEfeitos = true then
    sintsom ('dtfm_5')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD5', 1); {'Com o tocador 5'}
    player := sintambiente('VOXTUBE','TOCADOR5');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR5');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 5);
            end;

        '\': begin   //Sexto tocador
            if comEfeitos = true then
    sintsom ('dtfm_6')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD6', 1); {'Com o tocador 6'}
    player := sintambiente('VOXTUBE','TOCADOR6');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR6');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 6);
            end;

        '|': begin   //Stimo tocador
            if comEfeitos = true then
    sintsom ('dtfm_6')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD7', 1); {'Com o tocador 7'}
    player := sintambiente('VOXTUBE','TOCADOR7');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR7');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 7);
            end;

                 'W','w': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
            if quantNoYouTube < 2 then
            begin
            sintWriteInt (quantNoYouTube);
            mensagem('VTVIDEO', 1); {'Vdeo'}
            end
            else
            begin
            sintWriteInt (quantNoYouTube);
            mensagem('VTVIDEOS', 1); {' Videos '}
            end;
            end;

        ^w: begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
            if pagNoYouTube < 1 then
            begin
            mensagem('VTUMAPG', 1); {'Uma pgina'}
            exit;
            end;
            if pagNoYouTube = 1 then
            begin
            mensagem('VTDUASPG', 1); {'Duas pginas'}
            end
            else
            begin
            sintWriteInt (pagNoYouTube+1);
            mensagem('VTPAGS', 1); {'Pginas'}
    end;
    end;

        '', '': begin //Primeiro tocador
            if comEfeitos = true then
    sintsom ('dtfm_1')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD1', 1); {'Com o tocador 1'}
    player := sintambiente('VOXTUBE','TOCADOR1');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR1');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 1);
            end;

        'X','x': begin //Segundo tocador
            if comEfeitos = true then
    sintsom ('dtfm_2')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD2', 1); {'Com o tocador 2'}
    player := sintambiente('VOXTUBE','TOCADOR2');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR2');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 2);
            end;

        ^x: begin //Terceiro tocador
            if comEfeitos = true then
    sintsom ('dtfm_3')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD3', 1); {'Com o tocador 3'}
    player := sintambiente('VOXTUBE','TOCADOR3');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR3');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 3);
            end;

        'Y','y': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
atualizaYoutubedl;
atualizaVoxtube;
        end;

        'Z': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
letrasNaMemoria;
end;

        'z': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    lm := sintambiente('VOXTUBE','LETRAMEMORIA');
        mensagem('VTDIGLEM', 1); {'Digite a letra das memrias: '}
    sintetiza (letraMemoria);
    c := sintEdita (letraMemoria, wherex, wherey, 255, true);
            strPCopy (sz, maiuscAnsi(letraMemoria));
            writePrivateProfileString('VOXTUBE', 'LETRAMEMORIA',     sz, 'DOSVOX.INI');
    letraMemoria := sintambiente('VOXTUBE','LETRAMEMORIA');
    if letraMemoria = '' then
letraMemoria := lm;
    if c = esc then
Begin
letraMemoria := lm;

        mensagem ('VTCNTFOL', 1);  {'Continue folheando ou tecle ESC'}
letrasNaMemoria;
exit;
end;
            strPCopy (sz, maiuscAnsi(letraMemoria));
            writePrivateProfileString('VOXTUBE', 'LETRAMEMORIA',     sz, 'DOSVOX.INI');
letrasNaMemoria;
                  indice_atual := 0;
                end;

        ^z:  // CTRL+z   -->  titulo<crlf>paginaweb<crlf>
             begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                m := 0;
                for i := 1 to folheiaNumItens do
    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
    begin
                                filmeSelec := listaDeFilmes.O[i-1];
    m := m+1;
    end;
    end;
            if m > 1 then
                mensagem ('VTVIDEOS', 1)   {'Vdeos'}
            else
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
                m := 0;
                endereco := '';
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                filmeSelec := listaDeFilmes.O[i-1];
    sintWriteLn (intToStr (i));
    m := m+1;
                                endereco := clipboardAcum +
                                    'Ttulo: ' + Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'Contedo: ' + Utf8ToAnsi (filmeSelec['snippet']['description'].AsString) + CRLF + CRLF;
                                clipboardAcum := clipboardAcum +
                                    'Ttulo: ' + Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'Contedo: ' + Utf8ToAnsi (filmeSelec['snippet']['description'].AsString) + CRLF + CRLF;
                            end;
                    end;
                if (clipboardAcum = '') or (endereco = '') then
                    if (ultFolheado >= 1) and (ultFolheado <= folheiaNumItens) then
                            begin
                                filmeSelec := listaDeFilmes.O[ultFolheado-1];
    sintWriteLn (intToStr (ultFolheado));
                                endereco :=
                                    'Ttulo: ' + Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'Contedo: ' + Utf8ToAnsi (filmeSelec['snippet']['description'].AsString) + CRLF;
                                clipboardAcum :=
                                    'Ttulo: ' + Utf8ToAnsi (filmeSelec['snippet']['title'].AsString) + CRLF +
                                    'Contedo: ' + Utf8ToAnsi (filmeSelec['snippet']['description'].AsString) + CRLF;
                            end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;
nomeArq := (textoAProcurar + '.txt');
    dirGrava := (sintAmbiente('VOXTUBE', 'DIRVIDEOS'));
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio = '') and (dirGrava <> '') then
            nomeArq := dirGrava + '\' + nomeArq
        else
        if (pos ('\', nomeArq) = 0) and (pos ('/', nomeArq) = 0) and
           (diretorio <> '') then
            nomeArq := diretorio + '\' + nomeArq;
        if gravaAsBuscas or (tecla = 'L') then
        begin
    assign (nomeArquivo, nomeArq);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
            {$I-} rewrite(nomeArquivo);  {$i+}
If IOresult <> 0  Then
    begin
    {$I-} close(nomeArquivo){$I+};
    exit;
    end;
    end;
   writeln(nomeArquivo, endereco);
    {$I-} append (nomeArquivo); {$I+}
If IOresult <> 0  Then
    begin
    mensagem ('VTNOMINV', 1); {'Nome de arquivo invlido'}
            exit;
    end;
    {$I-} close(nomeArquivo){$I+};
        end;
                putClipboard (pchar(clipboardAcum));
            if m > 1 then
            mensagem('VTBLKCRGS', 1) {'Carregados'}
            else
            mensagem('VTBLKCRG', 1); {'Carregado'}
            if gravaAsBuscas = true then
            if m > 1 then
            mensagem('VTGRAVADS', 1) {'Gravados'}
            else
            mensagem('VTGRAVAD', 1); {'Gravado'}
    if not gravaAsBuscas then
exit
else
    mensagem ('VTDESEDI', 0);    {'Deseja editar o arquivo? '}
    c := sintReadKey;
    writeln (c);
    if (upcase(c) = 'N') or (upcase(c) = ESC) or (upcase(c) = BAIX) then
    exit;
    if upcase(c) <> 'S' then
    goto denovo1;
    if upcase(c) = 'S' then
        begin
    nomeProg := (sintambiente('DOSVOX','PGMDOSVOX') + '\edivox.exe ');
            if executaProg(nomeProg, '', '/L ' + '"' + nomeArq + '"') then
                begin
                    esperaProgVoltar;
            if comEfeitos = true then
    sintsom ('closewindow');
                    delay (5);
                end
            else
                begin
                    mensagem ('VTERREDI', 1);    {'Erro ao acionar o editor de textos'}
                    exit;
                end;
        end;
        end;

        ';': begin
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
            mensagem ('VTINIC',0);    {'Programa de Pesquisa no YouTube'}
            sintWriteln (VERSAO);
        end;

        #0:  case c2 of
                 F1: begin
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
                ajuda;
end;

                 F2: begin
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                 mensagem ('VTMOMENT', 1);   {'Um momento.'}
            mensagem('VTBAIVID', 1); {'Baixando em mp4 o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
    salvaFilme (infoFilme);
end;

                 F3: begin
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            mensagem('VTBAVIDE', 1); {'Baixando o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
    mensagem ('VTMP4MP3', 1); {' em mp4, para obter o udio em mp3, aguarde.'}
                Extraiaudio(infofilme);
end;

F4: begin
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
ref := vpp;
formConfig;
    vpp := sintambiente('VOXTUBE','VIDEOSPORPAGINA');
if vpp <> ref then
begin
                  indice_atual := 0;
                  mensagem ('VTFOLTRM', 1); {'Folheamento dos vdeos terminado'}
end
else;
end;

                 CTLF1: begin
    sintInic (2, dir);
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    exit;
end;

                 CTLF2: begin
    sintInic (3, dir);
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    exit;
end;

                 CTLF3: begin
    sintInic (4, dir);
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    exit;
end;

                 CTLF4: begin
    sintInic (5, dir);
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
    exit;
end;

        F5: begin //Tocador zero
            if comEfeitos = true then
    sintsom ('dtfm_4')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD0', 1); {'Com o tocador 0'}
    player := sintambiente('VOXTUBE','TOCADOR0');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR0');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 0);
            end;

        F12: begin //Primeiro tocador
            if comEfeitos = true then
    sintsom ('dtfm_1')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD1', 1); {'Com o tocador 1'}
    player := sintambiente('VOXTUBE','TOCADOR1');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR1');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 1);
            end;

        F6: begin //Segundo tocador
            if comEfeitos = true then
    sintsom ('dtfm_2')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD2', 1); {'Com o tocador 2'}
    player := sintambiente('VOXTUBE','TOCADOR2');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR2');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 2);
            end;

        F7: begin   //Terceiro tocador
            if comEfeitos = true then
    sintsom ('dtfm_3')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD3', 1); {'Com o tocador 3'}
    player := sintambiente('VOXTUBE','TOCADOR3');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR3');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 3);
            end;

        CTLF5: begin //Quarto tocador
            if comEfeitos = true then
    sintsom ('dtfm_4')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD4', 1); {'Com o tocador 4'}
    player := sintambiente('VOXTUBE','TOCADOR4');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR4');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 4);
            end;

        CTLF6: begin   //Quinto tocador
            if comEfeitos = true then
    sintsom ('dtfm_5')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD5', 1); {'Com o tocador 5'}
    player := sintambiente('VOXTUBE','TOCADOR5');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR5');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 5);
            end;

        CTLF7: begin   //Sexto tocador
            if comEfeitos = true then
    sintsom ('dtfm_6')
            else
            sintclek;
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
            if InformaOsTocadores = true then
begin
            mensagem('VTEXIBIN', 1); {'Exibindo o vdeo '}
    sintWriteLn (intToStr (ultFolheado));
            mensagem('VTTOCAD6', 1); {'Com o tocador 6'}
    player := sintambiente('VOXTUBE','TOCADOR6');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
            mensagem('VTTOCINT', 1); {'Interno'}
if player = 'ffplay' then
            mensagem('VTFFPLAY', 1); {'FFPlay'}
if player = 'mpc-hc' then
            mensagem('VTMPC-HC', 1); {'mpc-hc'}
if player = 'potplayerportable' then
            mensagem('VTPOTPLA', 1); {'PotPlayerPortable'}
if player = 'potplayermini' then
            mensagem('VTPOTPLI', 1); {'PotPlayerMini'}
if player = 'vlc' then
            mensagem('VTVLC', 1); {'VLC'}
if player = 'kmplayer' then
            mensagem('VTKMPLAY', 1); {'KMPlayer'}
if player = 'mpc-be' then
            mensagem('VTMPC-BE', 1); {'mpc-be'}
if player = 'gomplayer' then
            mensagem('VTGOM', 1); {'GOMPlayer'}
end;
if (player <> 'INTERNO') and
(player <> 'ffplay') and
(player <> 'mpc-hc') and
(player <> 'potplayerportable') and
(player <> 'potplayermini') and
(player <> 'vlc') and
(player <> 'kmplayer') and
(player <> 'mpc-be') and
(player <> 'gomplayer') then
    sintWriteLn (player);
    end;
    player := sintambiente('VOXTUBE','TOCADOR6');
    player := simplifica (player);
                i := pos ('.exe', player);
            if i >= 0 then
begin
delete (player , i, 4);
if player = 'INTERNO' then
                mensagem ('VTESCSAI', 1);   {'Escape sai do vdeo'}
end;
    infoFilme := obtemInfoFilme (ultFolheado);
                tocavideo (infoFilme.paginaWeb, NOPLAYER, 6);
            end;

                 F9: begin
            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
                        if ultFolheado > 0 then
                            begin
                                writeln (infoFilme.titulo);
                                writeln;
                            end;

                         c1 := selSetasOpcao;
                         goto denovo;
                     end;
             end;
    end;
end;

{--------------------------------------------------------}
{       folheia os vdeos informados pelo youtube
{--------------------------------------------------------}

procedure folheiaVideos (var indice_atual: integer);
var c1, c2: char;
    mudouPagina: boolean;
    titulo: string;
    s: string;
    infoFilme: TInfoFilme;
    filme: ISuperObject;

begin
    vpp := sintambiente('VOXTUBE','VIDEOSPORPAGINA');
    ultFolheado := 1;
    repeat
        clrscr;

        if folheiaExecuta(ultFolheado, ultFolheado, c1, c2, true) then
    begin
            processaFuncao (c1, c2, ultFolheado, indice_atual, mudouPagina);
            case c2 of

        F8:      falaHora;
        CTLF8:   falaDia;

            #75: begin //Setaesquerda
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
    infoFilme := obtemInfoFilme (ultFolheado);
                 if (infoFilme.duracao div 60) = 0 then
                 begin
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                     sintWriteln (intToStr (infoFilme.duracao mod 60));
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
                 end
                 else
                 begin
                     sintWriteln (intToStr (infoFilme.duracao div 60));
                     if (intToStr (infoFilme.duracao div 60)) = '1' then
            mensagem('VTMINUTO', 1) {'Minuto'}
            else
            mensagem('VTMINUTS', 1); {'Minutos'}
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
                                 sintWriteln  (intToStr (infoFilme.duracao mod 60));
            begin
                     if (intToStr (infoFilme.duracao mod 60)) = '1' then
            mensagem('VTSEGUND', 1) {' segundo'}
            else
                     if (intToStr (infoFilme.duracao mod 60) = '0') then
else
            mensagem('VTSEGUNS', 1); {' segundos'}
            end;
                 end;
                 end;

            #77: begin //Setadireita
            if comEfeitos = true then
    sintsom ('waterdrop')
            else
            sintclek;
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintetiza (intToStr (ultFolheado));
            filme := listaDeFilmes.O[ultFolheado-1];
            s := filme['snippet']['title'].AsString;
            titulo := formata (Utf8ToAnsi(s));
            sintsoletra (titulo);
            end;

        CTLDIR: begin
            if comEfeitos = true then
    sintsom ('VTPAGINA');
maxPag := 500 div strToInt(vpp);
                if tokenProxPag <>'' then
                begin
                    indice_atual := indice_atual + strToInt(vpp);
num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                    mudouPagina := true;
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
    sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
sintWriteInt ((num-1) * strToInt(vpp)+1);
                end
                else
            begin
            mensagem('VTULTPAG', 1); {'ltima pgina'}
    sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
num := (indice_atual+ultFolheado-2) div strToInt(vpp);
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
    sintWriteLn(intToStr (indice_atual+ultFolheado-1));
            end;
             end;

        CTLESQ: begin
            if comEfeitos = true then
    sintsom ('VTPAGINA');
maxPag := 500 div strToInt(vpp);
            if pagNoYouTube+1 > maxPag then
            else
                    indice_atual := indice_atual + strToInt(vpp);
                num := (indice_atual+ultFolheado-2) div strToInt(vpp);
begin
            if num = 1 then
begin
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
            end;
    if (num > pagNoYouTube+1) or (num < 1) then
    begin
            mensagem('VTPRIPAG', 1); {'Primeira pgina'}
                num := (indice_atual+ultFolheado-2) div strToInt(vpp)+1;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp));
    end;
                indice_atual := 0;
                indice_atual := (num * strToInt(vpp)) - (indice_atual + strToInt(vpp)-1);
if num = (1) then tokenProxPag := 'CBkQAQ';
if num = (2) then tokenProxPag := 'CBkQAA';
if num = (3) then tokenProxPag := 'CDIQAA';
if num = (4) then tokenProxPag := 'CEsQAA';
if num = (5) then tokenProxPag := 'CGQQAA';
if num = (6) then tokenProxPag := 'CH0QAA';
if num = (7) then tokenProxPag := 'CJYBEAA';
if num = (8) then tokenProxPag := 'CK8BEAA';
if num = (9) then tokenProxPag := 'CMgBEAA';
if num = (10) then tokenProxPag := 'COEBEAA';
if num = (11) then tokenProxPag := 'CPoBEAA';
if num = (12) then tokenProxPag := 'CJMCEAA';
if num = (13) then tokenProxPag := 'CKwCEAA';
if num = (14) then tokenProxPag := 'CMUCEAA';
if num = (15) then tokenProxPag := 'CN4CEAA';
if num = (16) then tokenProxPag := 'CPcCEAA';
if num = (17) then tokenProxPag := 'CJADEAA';
if num = (18) then tokenProxPag := 'CKkDEAA';
if num = (19) then tokenProxPag := 'CMIDEAA';
if num = (maxPag) then tokenProxPag := 'CNsDEAA';
                    tokenPag:=tokenProxPag;
                mudouPagina := true;
            if (num = maxPag) or (num = 1) then
            else
            if comEfeitos = true then
            else
            mensagem('VTPAG', 1); {'Pgina '}
                sintetiza (intToStr ((indice_atual+ultFolheado-2) div strToInt(vpp)+1));
                mensagem ('VTVIDEO', 1);   {'Vdeo'}
num := (indice_atual+ultFolheado-2) div strToInt(vpp);
sintWriteInt (num * strToInt(vpp)+1);
    end;
end;

        end;
    end

        else

    until mudouPagina or (indice_atual = 0);
end;

{--------------------------------------------------------}
{                   mostra ou fala cabealho
{--------------------------------------------------------}

procedure cabecalho;
var parm: array [0..255] of char;
    s, s1, nomeDir, nome: string;
    arqOut: file;
    x: integer;
    textoAProcurar: string;
    sz: array [0..144] of char;
label pula;
begin
    textbackground (BLUE);
    if iniciandoProg then
        begin
            mensagem ('VTINIC',0);    {'Programa de Pesquisa no YouTube'}
            sintWriteln (VERSAO);

    s := sintAmbiente ('VOXTUBE', 'LETRAMEMORIA');
    if s = '' then
    s := 'P';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'LETRAMEMORIA', (parm), 'DOSVOX.INI');

    s1 := sintAmbiente ('VOXTUBE', 'VERSAO');
                x := pos (s1, (VERSAO));

if x = 0 then
else
begin
    letraMemoria := sintambiente('VOXTUBE','LETRAMEMORIA');
letrasNaMemoria;
end;

begin
    nomeDir := sintambiente('DOSVOX','PGMDOSVOX');
nome := (nomeDir + '\' + 'wget.exe');
    assignFile (arqout, nome);
    {$I-} reset (arqout, 1); {$I+}
    if ioresult = 0 then
    else
    begin
            mensagem ('VTYTDLNAOS', 0); {'O arquivo Wget no foi encontrado, por favor reinstale o Voxtube'}
    clrscr;
            if comEfeitos = true then
    sintsom ('byebye');
    mensagem ('VTFIM',1); {'Fim do programa'}
            if comEfeitos = true then
    sintsom ('zoomaway');
    delay (100);
    sintfim;
    doneWinCrt;
end;
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
if textoAProcurar = '' then
begin
    writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO', sz, 'DOSVOX.INI');
end;
end;

//Gravando o setor [VOXTUBE] do dosvox.ini

    s := sintAmbiente ('PROGREDE', 'REDE30');
    if s = '' then
    s := 'V,C:\Winvox\VOXTUBE.EXE,-RDVOXTUB,VoxTube - acesso ao YouTube';
            strPCopy (parm, s);
    writePrivateProfileString ('PROGREDE', 'REDE30', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('DOSVOX', 'PGMDOSVOX');
    if s <> '' then
    s := (s + '\som\voxtube')
    else
    s := 'C:\Winvox\som\voxtube';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'DIRVOXTUBE', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if s = '' then
    s := '0';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'VELOCIDADE', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'VIDEOSPORPAGINA');
    if s = '' then
    s := '25';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'VIDEOSPORPAGINA', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    s := 'SIM';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'INFORMATOCADOR', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
begin
    s := 'SIM';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'ACIONAEFEITOS', (parm), 'DOSVOX.INI');
            comEfeitos := true;
end;

    s := sintAmbiente ('VOXTUBE', 'ATUALIZA');
    if s = '' then
    s := 'SIM';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'ATUALIZA', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    s := 'NO';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'GRAVABUSCA', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'DIRVIDEOS');
    if s = '' then
    s := '.';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'DIRVIDEOS', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    s := 'SIM';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'MP4APAGA', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'SAPIATIVADO');
    if s = '' then
    s := 'NO';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'SAPIATIVADO', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TIPOSAPI');
    if s = '' then
    s := '3';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TIPOSAPI', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'NUMEROSAPI');
    if s = '' then
    s := '1';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'NUMEROSAPI', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADESAPI');
    if s = '' then
    s := '0';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'VELOCIDADESAPI', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TONALIDADESAPI');
    if s = '' then
    s := '0';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TONALIDADESAPI', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'AUDIOBITRATE');
    if s = '' then
    s := '128000';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'AUDIOBITRATE', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'AUDIORESAMPLE');
    if s = '' then
    s := '44100';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'AUDIORESAMPLE', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'AUDIOCHANELS');
    if s = '' then
    s := '2';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'AUDIOCHANELS', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR0');
    if (s = '') or (s = 'INTERNO') or (s = 'INT') then
    s := 'INTERNO';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR0', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR1');
    if s = '' then
    s := 'C:\Winvox\ffplay.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR1', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR2');
    if s = '' then
    s := 'C:\Winvox\mpc-hc\mpc-hc.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR2', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR3');
    if s = '' then
    s := 'C:\Winvox\potplayerportable\PotPlayerPortable.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR3', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR4');
    if s = '' then
    s := 'C:\Winvox\vlc\vlc.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR4', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR5');
    if s = '' then
    s := 'C:\Winvox\kmplayer\KMPlayer.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR5', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR6');
    if s = '' then
    s := 'C:\Winvox\mpc-be\mpc-be.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR6', (parm), 'DOSVOX.INI');

    s := sintAmbiente ('VOXTUBE', 'TOCADOR7');
    if s = '' then
    s := 'C:\Winvox\gomplayer\GOM.exe';
            strPCopy (parm, s);
    writePrivateProfileString ('VOXTUBE', 'TOCADOR7', (parm), 'DOSVOX.INI');

//Final da gravao do setor [VOXTUBE] do dosvox.ini

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if (s = '') or (s= 'S') or (s= 'SIM') then
    comEfeitos := true;

    s1 := sintAmbiente ('VOXTUBE', 'VERSAO');
                x := pos (s1, (VERSAO));

    s := sintAmbiente ('VOXTUBE', 'ATUALIZA');
    if s = '' then
    begin
    fazAtualizacaoAutomatica := copy (sintAmbiente ('VOXTUBE', 'ATUALIZA'), 1, 1) = 'N'
    end
else
if (x = 0) or (s1 = '') then
begin
atualizaYoutubedl;
atualizaVoxtube;
end
else
    fazAtualizacaoAutomatica := copy (sintAmbiente ('VOXTUBE', 'ATUALIZA'), 1, 1) <> 'N';
        if fazAtualizacaoAutomatica then
begin
atualizaYoutubedl;
atualizaVoxtube;
end;

    s := sintAmbiente ('VOXTUBE', 'GRAVABUSCA');
    if s = '' then
    begin
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) = 'N';
    end
    else
    gravaAsBuscas := copy (sintAmbiente ('VOXTUBE', 'GRAVABUSCA'), 1, 1) <> 'N';
        if gravaAsBuscas then
begin
  gravaAsBuscas :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'INFORMATOCADOR');
    if s = '' then
    begin
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) = 'N';
    end
    else
    informaOsTocadores := copy (sintAmbiente ('VOXTUBE', 'INFORMATOCADOR'), 1, 1) <> 'N';
        if informaOsTocadores then
begin
  informaOsTocadores :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS');
    if s = '' then
    begin
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) = 'N';
    end
    else
    comEfeitos := copy (sintAmbiente ('VOXTUBE', 'ACIONAEFEITOS'), 1, 1) <> 'N';
        if comEfeitos then
begin
  comEfeitos :=true;
end;

    s := sintAmbiente ('VOXTUBE', 'MP4APAGA');
    if s = '' then
    begin
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) = 'N';
    end
    else
    apagaArqMp4 := copy (sintAmbiente ('VOXTUBE', 'MP4APAGA'), 1, 1) <> 'N';
        if apagaArqMp4 then
begin
  apagaArqMp4 :=true;
end;

    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if confApaga = 'S' then
    apagaArqMp4 :=true
    else
  apagaArqMp4 :=false;

    confApaga  := (sintAmbiente('VOXTUBE', 'MP4APAGA'));
    if confApaga = 'N' then
    apagaArqMp4 :=false
    else
  apagaArqMp4 :=true;

            iniciandoProg := false;
        end
    else
        writeln (pegaTextoMensagem('VTINIC') + VERSAO);
    textbackground (BLACK);
end;

{--------------------------------------------------------}
{                   programa principal
{--------------------------------------------------------}

procedure processaBusca (busca: string);
var
    indice_atual: integer;
    s: string;

begin
    indice_atual := 1;
    repeat
        gotoxy (1, 3);
        s := pedeAoYoutube (pedeListaVideos(busca));
        debuga (s);
        if s <> '' then
            begin
                if montaFolheamento (s, indice_atual) then
                     folheiaVideos (indice_atual);
                folheiaDestroi;
            end;
    until (s = '') or (quantNoYouTube = 0) or (indice_atual = 0);
end;

{--------------------------------------------------------}
{                   programa principal
{--------------------------------------------------------}

var
    sz: array [0..144] of char;
    c: char;
    dir, busca, nomeDir, nome: string;
     s, textoAProcurar: string;
     erro: integer;
    comSapi: boolean;
     velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
    memo0, memo1, memo2, memo3, memo4, memo5, memo6, memo7, memo8, memo9, memo10: string;

label inicio, denovo, fim;
begin

    clrscr;
    iniciandoProg := true;
    InformaAsVisualizacoes := true;
    dir := sintambiente('VOXTUBE', 'DIRVOXTUBE');
    if dir = '' then
        dir := '\Winvox\som\voxtube';

    s := sintAmbiente ('VOXTUBE', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 3
    else
        val (s, velGeral, erro);
    sintInic (velGeral, dir);
    c := primeiraLetra (sintAmbiente('VOXTUBE', 'SAPIATIVADO'));

    if trim(c) = '' then
        begin
            comSapi := copy (sintAmbiente ('TRADUTOR', 'SAPI'), 1, 1) <> 'N';
            if comSapi then
                begin
                    val (sintAmbiente('SERVFALA', 'VOZ'), confNum, erro);
                    if erro <> 0 then val (sintAmbiente('VOXTUBE', 'NUMEROSAPI'), confNum, erro);
                    if erro <> 0 then confNum := 1;

                    val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
                    if erro <> 0 then val (sintAmbiente('VOXTUBE', 'TIPOSAPI'), confTipoSapi, erro);
                    if erro <> 0 then confTipoSapi := 3;

                    val (sintAmbiente('SERVFALA', 'VELOCIDADE'), confVeloc, erro);
                    if erro <> 0 then val (sintAmbiente('VOXTUBE', 'VELOCIDADESAPI'), confVeloc, erro);
                    if erro <> 0 then confVeloc:= 0;

                    val (sintAmbiente('SERVFALA', 'TOM'), confTonal, erro);
                    if erro <> 0 then val (sintAmbiente('VOXTUBE', 'TONALIDADESAPI'), confTonal, erro);
                    if erro <> 0 then confTonal:= 0;

                    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
                end;
        end
    else
        begin
            comSapi := upcase(c) = 'S';
            val (sintAmbiente('VOXTUBE', 'NUMEROSAPI'), confNum, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'VOZ'), confNum, erro);
            if erro <> 0 then confNum := 1;

            val (sintAmbiente('VOXTUBE', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then val (sintAmbiente('SERVFALA', 'TIPOSAPI'), confTipoSapi, erro);
            if erro <> 0 then confTipoSapi := 3;

            val (sintAmbiente('VOXTUBE', 'VELOCIDADESAPI'), confVeloc, erro);
            if erro <> 0 then confVeloc:= 0;
            val (sintAmbiente('VOXTUBE', 'TONALIDADESAPI'), confTonal, erro);
            if erro <> 0 then confTonal:= 0;

            sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);

        end;

    repeat
        window (1, 1, 80, 25);
        clrscr;
        cabecalho;

    consisteDirArq;
    consisteDirVideos;
    letraMemoria := sintambiente('VOXTUBE','LETRAMEMORIA');
    if letraMemoria = '' then
        begin
            letraMemoria := 'P';
        end;

    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    memo0 := sintambiente('VOXTUBE','C' + letraMemoria + '0');
    memo1 := sintambiente('VOXTUBE','C' + letraMemoria + '1');
    memo2 := sintambiente('VOXTUBE','C' + letraMemoria + '2');
    memo3 := sintambiente('VOXTUBE','C' + letraMemoria + '3');
    memo4 := sintambiente('VOXTUBE','C' + letraMemoria + '4');
    memo5 := sintambiente('VOXTUBE','C' + letraMemoria + '5');
    memo6 := sintambiente('VOXTUBE','C' + letraMemoria + '6');
    memo7 := sintambiente('VOXTUBE','C' + letraMemoria + '7');
    memo8 := sintambiente('VOXTUBE','C' + letraMemoria + '8');
    memo9 := sintambiente('VOXTUBE','C' + letraMemoria + '9');
    memo10 := sintambiente('EDIVOX','TEXTOPROCURADO');

    busca := textoAProcurar;
    if (memo0 = '') and
    (memo1 = '') and
    (memo2 = '') and
    (memo3 = '') and
    (memo4 = '') and
    (memo5 = '') and
    (memo6 = '') and
    (memo7 = '') and
        (memo8 = '') and
    (memo9 = '') and
    (memo10 = '') then
        mensagem ('VTDIGBUC', 0)  {'Digite sua busca'}
    else
        mensagem ('VTDIGBUS', 0);  {'Digite sua busca, ou use as setas para folhear a memria'}
    sintetiza (busca);
    begin

    c := pegaUltimosComandos (busca, 'VOXTUBE', 'C' + letraMemoria);

    if busca = '' then
    busca := textoAProcurar;
            strPCopy (sz, busca);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');
    end;
titulojan := busca + ' - VoxTube ' + VERSAO;
    setWindowTitle(titulojan);

        if c = ESC then break;

            if comEfeitos = true then
    sintsom ('clickfast')
            else
            sintclek;
configurando;

        processaBusca (busca);

        clrscr;

        denovo:
tokenProxPag := 'CBkQAQ';
                    tokenPag:=tokenProxPag;

        c := 'S';
//        mensagem ('VTOUTRO', 0);   {'Deseja pesquisar outro assunto? '}
//        c := sintReadkey;
        writeln (c);
    if (upcase(c) <> 'S') and (upcase(c) <> 'N') and (upcase(c) <> BAIX) and (upcase(c) <> ESC) then
        goto denovo;
    until (upcase(c) = 'N') or (upcase(c) = BAIX) or (upcase(c) = ESC);

    clrscr;
            if comEfeitos = true then
    sintsom ('byebye');
    mensagem ('VTFIM',1); {'Fim do programa'}
            if comEfeitos = true then
    sintsom ('zoomaway');
    delay (100);

    s := (VERSAO);
            strPCopy (sz, s);
            writePrivateProfileString('VOXTUBE', 'VERSAO',     sz, 'DOSVOX.INI');

    sintfim;
    doneWinCrt;
end.
